/* A Bison parser, made by GNU Bison 2.7.  */

/* Skeleton implementation for Bison LALR(1) parsers in C++
   
      Copyright (C) 2002-2012 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */


/* First part of user declarations.  */

/* Line 279 of lalr1.cc  */
#line 38 "ds9parse.cpp"


#include "ds9parse.hpp"

/* User implementation prologue.  */

/* Line 285 of lalr1.cc  */
#line 46 "ds9parse.cpp"
/* Unqualified %code blocks.  */
/* Line 286 of lalr1.cc  */
#line 23 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"


#ifdef yylex
#undef yylex
#endif

#include <math.h>
#include <string.h>
#include <iostream>
#include <list>

#include "ParserDs9.h"
#include "ContextDs9.h"
#include "ds9parse.hpp"
#include "ds9lex.h"

#define YYDEBUG 1
#define POINTSIZE 11

#define FITSPTR (fr)
#define DISCARD_(x) {yyclearin; driver.lexer->discard(x);}




const int MAXANNULI = 512;
const int MAXANGLES = 720;


extern int mklex(void*, FlexLexer*);
extern void mkerror(ContextDs9*, FlexLexer*, const char*);
extern void mkDiscard(int);

static  CoordSystem globalSystem;
static  CoordSystem globalWCS;
static  SkyFrame globalSky;
static  CoordSystem localSystem;
static  SkyFrame localSky;

static int globalTile;

static unsigned short globalProps;
static unsigned short localProps;

static int globalDash[2];
static int localDash[2];

static int globalWidth;
static int localWidth;

static char globalColor[16];
static char localColor[16];

static char globalFont[32];
static char localFont[32];

static char globalText[80];
static char localText[80];

static char localComment[80];

static int globalLine1;
static int localLine1;
static int globalLine2;
static int localLine2;

static int globalVector;
static int localVector;

static int globalComposite;
static int localComposite;

static int globalPoint;
static int localPoint;
static int globalPointSize;
static int localPointSize;

static double globalTextAngle;
static double localTextAngle;
static int globalTextRotate;
static int localTextRotate;

static  CoordSystem globalRulerCoordSystem;
static  CoordSystem localRulerCoordSystem;
static  SkyFrame globalRulerSkyFrame;
static  SkyFrame localRulerSkyFrame;
static  CoordSystem globalRulerDistSystem;
static  CoordSystem localRulerDistSystem;
static  SkyDist globalRulerDistFormat;
static  SkyDist localRulerDistFormat;

static  CoordSystem globalCompassCoordSystem;
static  SkyFrame globalCompassSkyFrame;
static char globalCompassNorth[80];
static char globalCompassEast[80];
static int globalCompassNArrow;
static int globalCompassEArrow;
static  CoordSystem localCompassCoordSystem;
static  SkyFrame localCompassSkyFrame;
static char localCompassNorth[80];
static char localCompassEast[80];
static int localCompassNArrow;
static int localCompassEArrow;

static int localCpanda;
static int localEpanda;
static int localBpanda;

static std::list<Vertex> polylist;
static std::list<Tag> taglist;
static std::list<CallBack> cblist;

static double aAnnuli[MAXANNULI];
static Vector aVector[MAXANNULI];
static int aNum;
static int aNumsao;
static int aStatus;
static int cStatus;
static Vector aCenter;
static double aAngles[MAXANGLES];
static int aAngNum;
static double aAngle;
static unsigned short aProps;
static char aColor[16];
static int aWidth;
static int aDash[2];
static char aFont[32];
static char aText[80];
static char aComment[80];

static void setProps(unsigned short* props, unsigned short prop, int value);
static  CoordSystem checkWCSSystem();
static  SkyFrame checkWCSSky();


#include <ds9lex.h>
#undef yylex
#define yylex driver.lexer->lex




/* Line 286 of lalr1.cc  */
#line 193 "ds9parse.cpp"


# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* FIXME: INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (/*CONSTCOND*/ false)
# endif


/* Suppress unused-variable warnings by "using" E.  */
#define YYUSE(e) ((void) (e))

/* Enable debugging if requested.  */
#if YYDEBUG

/* A pseudo ostream that takes yydebug_ into account.  */
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)	\
do {							\
  if (yydebug_)						\
    {							\
      *yycdebug_ << Title << ' ';			\
      yy_symbol_print_ ((Type), (Value), (Location));	\
      *yycdebug_ << std::endl;				\
    }							\
} while (false)

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug_)				\
    yy_reduce_print_ (Rule);		\
} while (false)

# define YY_STACK_PRINT()		\
do {					\
  if (yydebug_)				\
    yystack_print_ ();			\
} while (false)

#else /* !YYDEBUG */

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Type, Value, Location) YYUSE(Type)
# define YY_REDUCE_PRINT(Rule)        static_cast<void>(0)
# define YY_STACK_PRINT()             static_cast<void>(0)

#endif /* !YYDEBUG */

#define yyerrok		(yyerrstatus_ = 0)
#define yyclearin	(yychar = yyempty_)

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)


namespace yy {
/* Line 353 of lalr1.cc  */
#line 288 "ds9parse.cpp"

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  ds9parse::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr = "";
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              /* Fall through.  */
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }


  /// Build a parser object.
  ds9parse::ds9parse (class ParserDs9& driver_yyarg, class ContextDs9* fr_yyarg)
    :
#if YYDEBUG
      yydebug_ (false),
      yycdebug_ (&std::cerr),
#endif
      driver (driver_yyarg),
      fr (fr_yyarg)
  {
  }

  ds9parse::~ds9parse ()
  {
  }

#if YYDEBUG
  /*--------------------------------.
  | Print this symbol on YYOUTPUT.  |
  `--------------------------------*/

  inline void
  ds9parse::yy_symbol_value_print_ (int yytype,
			   const semantic_type* yyvaluep, const location_type* yylocationp)
  {
    YYUSE (yylocationp);
    YYUSE (yyvaluep);
    std::ostream& yyo = debug_stream ();
    std::ostream& yyoutput = yyo;
    YYUSE (yyoutput);
    switch (yytype)
      {
         default:
	  break;
      }
  }


  void
  ds9parse::yy_symbol_print_ (int yytype,
			   const semantic_type* yyvaluep, const location_type* yylocationp)
  {
    *yycdebug_ << (yytype < yyntokens_ ? "token" : "nterm")
	       << ' ' << yytname_[yytype] << " ("
	       << *yylocationp << ": ";
    yy_symbol_value_print_ (yytype, yyvaluep, yylocationp);
    *yycdebug_ << ')';
  }
#endif

  void
  ds9parse::yydestruct_ (const char* yymsg,
			   int yytype, semantic_type* yyvaluep, location_type* yylocationp)
  {
    YYUSE (yylocationp);
    YYUSE (yymsg);
    YYUSE (yyvaluep);

    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

    switch (yytype)
      {
  
	default:
	  break;
      }
  }

  void
  ds9parse::yypop_ (unsigned int n)
  {
    yystate_stack_.pop (n);
    yysemantic_stack_.pop (n);
    yylocation_stack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  ds9parse::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  ds9parse::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  ds9parse::debug_level_type
  ds9parse::debug_level () const
  {
    return yydebug_;
  }

  void
  ds9parse::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif

  inline bool
  ds9parse::yy_pact_value_is_default_ (int yyvalue)
  {
    return yyvalue == yypact_ninf_;
  }

  inline bool
  ds9parse::yy_table_value_is_error_ (int yyvalue)
  {
    return yyvalue == yytable_ninf_;
  }

  int
  ds9parse::parse ()
  {
    /// Lookahead and lookahead in internal form.
    int yychar = yyempty_;
    int yytoken = 0;

    // State.
    int yyn;
    int yylen = 0;
    int yystate = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// Semantic value of the lookahead.
    static semantic_type yyval_default;
    semantic_type yylval = yyval_default;
    /// Location of the lookahead.
    location_type yylloc;
    /// The locations where the error started and ended.
    location_type yyerror_range[3];

    /// $$.
    semantic_type yyval;
    /// @$.
    location_type yyloc;

    int yyresult;

    // FIXME: This shoud be completely indented.  It is not yet to
    // avoid gratuitous conflicts when merging into the master branch.
    try
      {
    YYCDEBUG << "Starting parse" << std::endl;


    /* Initialize the stacks.  The initial state will be pushed in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystate_stack_ = state_stack_type (0);
    yysemantic_stack_ = semantic_stack_type (0);
    yylocation_stack_ = location_stack_type (0);
    yysemantic_stack_.push (yylval);
    yylocation_stack_.push (yylloc);

    /* New state.  */
  yynewstate:
    yystate_stack_.push (yystate);
    YYCDEBUG << "Entering state " << yystate << std::endl;

    /* Accept?  */
    if (yystate == yyfinal_)
      goto yyacceptlab;

    goto yybackup;

    /* Backup.  */
  yybackup:

    /* Try to take a decision without lookahead.  */
    yyn = yypact_[yystate];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    /* Read a lookahead token.  */
    if (yychar == yyempty_)
      {
        YYCDEBUG << "Reading a token: ";
        yychar = yylex (&yylval, &yylloc);
      }

    /* Convert token to internal form.  */
    if (yychar <= yyeof_)
      {
	yychar = yytoken = yyeof_;
	YYCDEBUG << "Now at end of input." << std::endl;
      }
    else
      {
	yytoken = yytranslate_ (yychar);
	YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
      }

    /* If the proper action on seeing token YYTOKEN is to reduce or to
       detect an error, take that action.  */
    yyn += yytoken;
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yytoken)
      goto yydefault;

    /* Reduce or error.  */
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
	if (yy_table_value_is_error_ (yyn))
	  goto yyerrlab;
	yyn = -yyn;
	goto yyreduce;
      }

    /* Shift the lookahead token.  */
    YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

    /* Discard the token being shifted.  */
    yychar = yyempty_;

    yysemantic_stack_.push (yylval);
    yylocation_stack_.push (yylloc);

    /* Count tokens shifted since error; after three, turn off error
       status.  */
    if (yyerrstatus_)
      --yyerrstatus_;

    yystate = yyn;
    goto yynewstate;

  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[yystate];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;

  /*-----------------------------.
  | yyreduce -- Do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    /* If YYLEN is nonzero, implement the default value of the action:
       `$$ = $1'.  Otherwise, use the top of the stack.

       Otherwise, the following line sets YYVAL to garbage.
       This behavior is undocumented and Bison
       users should not rely upon it.  */
    if (yylen)
      yyval = yysemantic_stack_[yylen - 1];
    else
      yyval = yysemantic_stack_[0];

    // Compute the default @$.
    {
      slice<location_type, location_stack_type> slice (yylocation_stack_, yylen);
      YYLLOC_DEFAULT (yyloc, slice, yylen);
    }

    // Perform the reduction.
    YY_REDUCE_PRINT (yyn);
    switch (yyn)
      {
          case 7:
/* Line 670 of lalr1.cc  */
#line 342 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {std::cerr << "DS9 Regions File 3.2" << std::endl;}
    break;

  case 9:
/* Line 670 of lalr1.cc  */
#line 345 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {globalTile = (yysemantic_stack_[(2) - (2)].integer);}
    break;

  case 10:
/* Line 670 of lalr1.cc  */
#line 347 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {globalSystem=( CoordSystem)(yysemantic_stack_[(1) - (1)].integer);}
    break;

  case 12:
/* Line 670 of lalr1.cc  */
#line 348 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {globalSystem=globalWCS; globalSky=( SkyFrame)(yysemantic_stack_[(1) - (1)].integer);}
    break;

  case 14:
/* Line 670 of lalr1.cc  */
#line 349 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {globalSystem=globalWCS; globalSky= FK5;}
    break;

  case 21:
/* Line 670 of lalr1.cc  */
#line 358 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {globalTile = (yysemantic_stack_[(2) - (2)].integer);}
    break;

  case 22:
/* Line 670 of lalr1.cc  */
#line 359 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {DISCARD_(1);}
    break;

  case 25:
/* Line 670 of lalr1.cc  */
#line 363 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {DISCARD_(1);}
    break;

  case 28:
/* Line 670 of lalr1.cc  */
#line 367 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {DISCARD_(1);}
    break;

  case 29:
/* Line 670 of lalr1.cc  */
#line 367 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {strncpy(localComment,(yysemantic_stack_[(4) - (3)].str),80);}
    break;

  case 31:
/* Line 670 of lalr1.cc  */
#line 369 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {DISCARD_(1);}
    break;

  case 32:
/* Line 670 of lalr1.cc  */
#line 369 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {strncpy(localComment,(yysemantic_stack_[(5) - (4)].str),80);}
    break;

  case 34:
/* Line 670 of lalr1.cc  */
#line 373 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {DISCARD_(1);}
    break;

  case 35:
/* Line 670 of lalr1.cc  */
#line 373 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {strncpy(localComment,(yysemantic_stack_[(3) - (2)].str),80);}
    break;

  case 37:
/* Line 670 of lalr1.cc  */
#line 375 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {DISCARD_(1);}
    break;

  case 38:
/* Line 670 of lalr1.cc  */
#line 375 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {strncpy(localComment,(yysemantic_stack_[(4) - (3)].str),80);}
    break;

  case 40:
/* Line 670 of lalr1.cc  */
#line 379 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {YYACCEPT;}
    break;

  case 41:
/* Line 670 of lalr1.cc  */
#line 382 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.real)=(yysemantic_stack_[(1) - (1)].real);}
    break;

  case 42:
/* Line 670 of lalr1.cc  */
#line 383 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.real)=(yysemantic_stack_[(1) - (1)].integer);}
    break;

  case 43:
/* Line 670 of lalr1.cc  */
#line 386 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {yydebug_=1;}
    break;

  case 44:
/* Line 670 of lalr1.cc  */
#line 387 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {yydebug_=0;}
    break;

  case 45:
/* Line 670 of lalr1.cc  */
#line 390 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer)=((yysemantic_stack_[(1) - (1)].integer) ? 1 : 0);}
    break;

  case 46:
/* Line 670 of lalr1.cc  */
#line 392 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer)=1;}
    break;

  case 47:
/* Line 670 of lalr1.cc  */
#line 393 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer)=1;}
    break;

  case 48:
/* Line 670 of lalr1.cc  */
#line 394 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer)=1;}
    break;

  case 49:
/* Line 670 of lalr1.cc  */
#line 395 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer)=1;}
    break;

  case 50:
/* Line 670 of lalr1.cc  */
#line 397 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer)=0;}
    break;

  case 51:
/* Line 670 of lalr1.cc  */
#line 398 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer)=0;}
    break;

  case 52:
/* Line 670 of lalr1.cc  */
#line 399 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer)=0;}
    break;

  case 53:
/* Line 670 of lalr1.cc  */
#line 400 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer)=0;}
    break;

  case 60:
/* Line 670 of lalr1.cc  */
#line 415 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {cStatus = 0;}
    break;

  case 61:
/* Line 670 of lalr1.cc  */
#line 416 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {cStatus = 1;}
    break;

  case 62:
/* Line 670 of lalr1.cc  */
#line 417 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {cStatus = 1;}
    break;

  case 63:
/* Line 670 of lalr1.cc  */
#line 420 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.real) = fr->mapAngleToRef(0,localSystem,localSky);}
    break;

  case 64:
/* Line 670 of lalr1.cc  */
#line 421 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.real) = (yysemantic_stack_[(1) - (1)].real);}
    break;

  case 65:
/* Line 670 of lalr1.cc  */
#line 424 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.real) = fr->mapAngleToRef(degToRad((yysemantic_stack_[(1) - (1)].real)),localSystem,localSky);}
    break;

  case 66:
/* Line 670 of lalr1.cc  */
#line 425 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.real) = fr->mapAngleToRef(degToRad((yysemantic_stack_[(1) - (1)].real)),localSystem,localSky);}
    break;

  case 67:
/* Line 670 of lalr1.cc  */
#line 426 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.real) = fr->mapAngleToRef((yysemantic_stack_[(1) - (1)].real),localSystem,localSky);}
    break;

  case 68:
/* Line 670 of lalr1.cc  */
#line 429 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.real) = FITSPTR->mapLenToRef((yysemantic_stack_[(1) - (1)].real), localSystem,  DEGREE);}
    break;

  case 69:
/* Line 670 of lalr1.cc  */
#line 430 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.real) = FITSPTR->mapLenToRef((yysemantic_stack_[(1) - (1)].real),  PHYSICAL);}
    break;

  case 70:
/* Line 670 of lalr1.cc  */
#line 431 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.real) = FITSPTR->mapLenToRef((yysemantic_stack_[(1) - (1)].real),  IMAGE);}
    break;

  case 71:
/* Line 670 of lalr1.cc  */
#line 432 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.real) = FITSPTR->mapLenToRef((yysemantic_stack_[(1) - (1)].real), checkWCSSystem(),  DEGREE);}
    break;

  case 72:
/* Line 670 of lalr1.cc  */
#line 433 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.real) = FITSPTR->mapLenToRef((yysemantic_stack_[(1) - (1)].real), checkWCSSystem(),  ARCMIN);}
    break;

  case 73:
/* Line 670 of lalr1.cc  */
#line 434 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.real) = FITSPTR->mapLenToRef((yysemantic_stack_[(1) - (1)].real), checkWCSSystem(),  ARCSEC);}
    break;

  case 74:
/* Line 670 of lalr1.cc  */
#line 438 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  Vector r = FITSPTR->mapLenToRef(doubletovec((yysemantic_stack_[(3) - (1)].real),(yysemantic_stack_[(3) - (3)].real)), localSystem,  DEGREE);
	  (yyval.vector)[0] = r[0];
	  (yyval.vector)[1] = r[1];
	  (yyval.vector)[2] = r[2];
	}
    break;

  case 75:
/* Line 670 of lalr1.cc  */
#line 445 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  Vector r = FITSPTR->mapLenToRef(doubletovec((yysemantic_stack_[(3) - (1)].real),(yysemantic_stack_[(3) - (3)].real)),  PHYSICAL);
	  (yyval.vector)[0] = r[0];
	  (yyval.vector)[1] = r[1];
	  (yyval.vector)[2] = r[2];
	}
    break;

  case 76:
/* Line 670 of lalr1.cc  */
#line 452 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  Vector r = FITSPTR->mapLenToRef(doubletovec((yysemantic_stack_[(3) - (1)].real),(yysemantic_stack_[(3) - (3)].real)),  IMAGE);
	  (yyval.vector)[0] = r[0];
	  (yyval.vector)[1] = r[1];
	  (yyval.vector)[2] = r[2];
	}
    break;

  case 77:
/* Line 670 of lalr1.cc  */
#line 459 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  Vector r=FITSPTR->mapLenToRef(doubletovec((yysemantic_stack_[(3) - (1)].real),(yysemantic_stack_[(3) - (3)].real)),checkWCSSystem(), DEGREE);
	  (yyval.vector)[0] = r[0];
	  (yyval.vector)[1] = r[1];
	  (yyval.vector)[2] = r[2];
	}
    break;

  case 78:
/* Line 670 of lalr1.cc  */
#line 466 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  Vector r=FITSPTR->mapLenToRef(doubletovec((yysemantic_stack_[(3) - (1)].real),(yysemantic_stack_[(3) - (3)].real)),checkWCSSystem(), ARCMIN);
	  (yyval.vector)[0] = r[0];
	  (yyval.vector)[1] = r[1];
	  (yyval.vector)[2] = r[2];
	}
    break;

  case 79:
/* Line 670 of lalr1.cc  */
#line 473 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  Vector r=FITSPTR->mapLenToRef(doubletovec((yysemantic_stack_[(3) - (1)].real),(yysemantic_stack_[(3) - (3)].real)),checkWCSSystem(), ARCSEC);
	  (yyval.vector)[0] = r[0];
	  (yyval.vector)[1] = r[1];
	  (yyval.vector)[2] = r[2];
	}
    break;

  case 80:
/* Line 670 of lalr1.cc  */
#line 481 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) = (yysemantic_stack_[(3) - (3)].integer);}
    break;

  case 81:
/* Line 670 of lalr1.cc  */
#line 484 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.real) = parseSEXStr((yysemantic_stack_[(1) - (1)].str));}
    break;

  case 82:
/* Line 670 of lalr1.cc  */
#line 487 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.real) = parseHMSStr((yysemantic_stack_[(1) - (1)].str));}
    break;

  case 83:
/* Line 670 of lalr1.cc  */
#line 490 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.real) = parseDMSStr((yysemantic_stack_[(1) - (1)].str));}
    break;

  case 84:
/* Line 670 of lalr1.cc  */
#line 494 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  Vector r;
	   CoordSystem sys = checkWCSSystem();
	   SkyFrame sky = checkWCSSky();
	  if (sky ==  GALACTIC || sky ==  ECLIPTIC) 
	    r = FITSPTR->mapToRef(doubletovec((yysemantic_stack_[(3) - (1)].real),(yysemantic_stack_[(3) - (3)].real)), sys, sky);
	  else
	    r = FITSPTR->mapToRef(doubletovec((yysemantic_stack_[(3) - (1)].real)*360./24.,(yysemantic_stack_[(3) - (3)].real)), sys, sky);
	  (yyval.vector)[0] = r[0];
	  (yyval.vector)[1] = r[1];
	  (yyval.vector)[2] = r[2];
	}
    break;

  case 85:
/* Line 670 of lalr1.cc  */
#line 507 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  Vector r = FITSPTR->mapToRef(doubletovec((yysemantic_stack_[(3) - (1)].real),(yysemantic_stack_[(3) - (3)].real)),
	  checkWCSSystem(), checkWCSSky());
	  (yyval.vector)[0] = r[0];
	  (yyval.vector)[1] = r[1];
	  (yyval.vector)[2] = r[2];
	}
    break;

  case 86:
/* Line 670 of lalr1.cc  */
#line 515 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  Vector r = FITSPTR->mapToRef(doubletovec((yysemantic_stack_[(3) - (1)].real),(yysemantic_stack_[(3) - (3)].real)),
	  checkWCSSystem(), checkWCSSky());
	  (yyval.vector)[0] = r[0];
	  (yyval.vector)[1] = r[1];
	  (yyval.vector)[2] = r[2];
	}
    break;

  case 87:
/* Line 670 of lalr1.cc  */
#line 523 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  Vector r = FITSPTR->mapToRef(doubletovec((yysemantic_stack_[(3) - (1)].real),(yysemantic_stack_[(3) - (3)].real)), localSystem, localSky);
	  (yyval.vector)[0] = r[0];
	  (yyval.vector)[1] = r[1];
	  (yyval.vector)[2] = r[2];
	}
    break;

  case 88:
/* Line 670 of lalr1.cc  */
#line 530 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  Vector r = FITSPTR->mapToRef(doubletovec((yysemantic_stack_[(3) - (1)].real),(yysemantic_stack_[(3) - (3)].real)), 
	    checkWCSSystem(), checkWCSSky());
	  (yyval.vector)[0] = r[0];
	  (yyval.vector)[1] = r[1];
	  (yyval.vector)[2] = r[2];
	}
    break;

  case 89:
/* Line 670 of lalr1.cc  */
#line 538 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  Vector r = FITSPTR->mapToRef(doubletovec((yysemantic_stack_[(3) - (1)].real),(yysemantic_stack_[(3) - (3)].real)),  IMAGE);
	  (yyval.vector)[0] = r[0];
	  (yyval.vector)[1] = r[1];
	  (yyval.vector)[2] = r[2];
	}
    break;

  case 90:
/* Line 670 of lalr1.cc  */
#line 545 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  Vector r = FITSPTR->mapToRef(doubletovec((yysemantic_stack_[(3) - (1)].real),(yysemantic_stack_[(3) - (3)].real)),  PHYSICAL);
	  (yyval.vector)[0] = r[0];
	  (yyval.vector)[1] = r[1];
	}
    break;

  case 91:
/* Line 670 of lalr1.cc  */
#line 552 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) =  IMAGE;}
    break;

  case 92:
/* Line 670 of lalr1.cc  */
#line 553 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) =  PHYSICAL;}
    break;

  case 93:
/* Line 670 of lalr1.cc  */
#line 554 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) =  DETECTOR;}
    break;

  case 94:
/* Line 670 of lalr1.cc  */
#line 555 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) =  AMPLIFIER;}
    break;

  case 95:
/* Line 670 of lalr1.cc  */
#line 556 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) = (yysemantic_stack_[(1) - (1)].integer); globalWCS = ( CoordSystem)(yysemantic_stack_[(1) - (1)].integer);}
    break;

  case 96:
/* Line 670 of lalr1.cc  */
#line 559 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) =  WCS;}
    break;

  case 97:
/* Line 670 of lalr1.cc  */
#line 560 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) =  WCSA;}
    break;

  case 98:
/* Line 670 of lalr1.cc  */
#line 561 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) =  WCSB;}
    break;

  case 99:
/* Line 670 of lalr1.cc  */
#line 562 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) =  WCSC;}
    break;

  case 100:
/* Line 670 of lalr1.cc  */
#line 563 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) =  WCSD;}
    break;

  case 101:
/* Line 670 of lalr1.cc  */
#line 564 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) =  WCSE;}
    break;

  case 102:
/* Line 670 of lalr1.cc  */
#line 565 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) =  WCSF;}
    break;

  case 103:
/* Line 670 of lalr1.cc  */
#line 566 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) =  WCSG;}
    break;

  case 104:
/* Line 670 of lalr1.cc  */
#line 567 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) =  WCSH;}
    break;

  case 105:
/* Line 670 of lalr1.cc  */
#line 568 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) =  WCSI;}
    break;

  case 106:
/* Line 670 of lalr1.cc  */
#line 569 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) =  WCSJ;}
    break;

  case 107:
/* Line 670 of lalr1.cc  */
#line 570 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) =  WCSK;}
    break;

  case 108:
/* Line 670 of lalr1.cc  */
#line 571 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) =  WCSL;}
    break;

  case 109:
/* Line 670 of lalr1.cc  */
#line 572 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) =  WCSM;}
    break;

  case 110:
/* Line 670 of lalr1.cc  */
#line 573 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) =  WCSN;}
    break;

  case 111:
/* Line 670 of lalr1.cc  */
#line 574 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) =  WCSO;}
    break;

  case 112:
/* Line 670 of lalr1.cc  */
#line 575 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) =  WCSP;}
    break;

  case 113:
/* Line 670 of lalr1.cc  */
#line 576 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) =  WCSQ;}
    break;

  case 114:
/* Line 670 of lalr1.cc  */
#line 577 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) =  WCSR;}
    break;

  case 115:
/* Line 670 of lalr1.cc  */
#line 578 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) =  WCSS;}
    break;

  case 116:
/* Line 670 of lalr1.cc  */
#line 579 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) =  WCST;}
    break;

  case 117:
/* Line 670 of lalr1.cc  */
#line 580 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) =  WCSU;}
    break;

  case 118:
/* Line 670 of lalr1.cc  */
#line 581 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) =  WCSV;}
    break;

  case 119:
/* Line 670 of lalr1.cc  */
#line 582 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) =  WCSW;}
    break;

  case 120:
/* Line 670 of lalr1.cc  */
#line 583 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) =  WCSX;}
    break;

  case 121:
/* Line 670 of lalr1.cc  */
#line 584 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) =  WCSY;}
    break;

  case 122:
/* Line 670 of lalr1.cc  */
#line 585 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) =  WCSZ;}
    break;

  case 123:
/* Line 670 of lalr1.cc  */
#line 586 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) =  WCS0;}
    break;

  case 124:
/* Line 670 of lalr1.cc  */
#line 589 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) =  FK4;}
    break;

  case 125:
/* Line 670 of lalr1.cc  */
#line 590 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) =  FK4;}
    break;

  case 126:
/* Line 670 of lalr1.cc  */
#line 591 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) =  FK4_NO_E;}
    break;

  case 127:
/* Line 670 of lalr1.cc  */
#line 592 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) =  FK5;}
    break;

  case 128:
/* Line 670 of lalr1.cc  */
#line 593 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) =  FK5;}
    break;

  case 129:
/* Line 670 of lalr1.cc  */
#line 594 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) =  ICRS;}
    break;

  case 130:
/* Line 670 of lalr1.cc  */
#line 595 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) =  GALACTIC;}
    break;

  case 131:
/* Line 670 of lalr1.cc  */
#line 596 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) =  SUPERGALACTIC;}
    break;

  case 132:
/* Line 670 of lalr1.cc  */
#line 597 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) =  ECLIPTIC;}
    break;

  case 133:
/* Line 670 of lalr1.cc  */
#line 598 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) =  HELIOECLIPTIC;}
    break;

  case 134:
/* Line 670 of lalr1.cc  */
#line 601 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer)= DEGREE;}
    break;

  case 135:
/* Line 670 of lalr1.cc  */
#line 602 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer)= ARCMIN;}
    break;

  case 136:
/* Line 670 of lalr1.cc  */
#line 603 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer)= ARCSEC;}
    break;

  case 137:
/* Line 670 of lalr1.cc  */
#line 606 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) = Marker::SELECT;}
    break;

  case 138:
/* Line 670 of lalr1.cc  */
#line 607 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) = Marker::HIGHLITE;}
    break;

  case 139:
/* Line 670 of lalr1.cc  */
#line 608 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) = Marker::DASH;}
    break;

  case 140:
/* Line 670 of lalr1.cc  */
#line 609 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) = Marker::FIXED;}
    break;

  case 141:
/* Line 670 of lalr1.cc  */
#line 610 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) = Marker::EDIT;}
    break;

  case 142:
/* Line 670 of lalr1.cc  */
#line 611 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) = Marker::MOVE;}
    break;

  case 143:
/* Line 670 of lalr1.cc  */
#line 612 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) = Marker::ROTATE;}
    break;

  case 144:
/* Line 670 of lalr1.cc  */
#line 613 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) = Marker::DELETE;}
    break;

  case 145:
/* Line 670 of lalr1.cc  */
#line 614 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) = Marker::INCLUDE;}
    break;

  case 146:
/* Line 670 of lalr1.cc  */
#line 615 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) = Marker::SOURCE;}
    break;

  case 147:
/* Line 670 of lalr1.cc  */
#line 618 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) = CallBack::SELECTCB;}
    break;

  case 148:
/* Line 670 of lalr1.cc  */
#line 619 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) = CallBack::UNSELECTCB;}
    break;

  case 149:
/* Line 670 of lalr1.cc  */
#line 620 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) = CallBack::HIGHLITECB;}
    break;

  case 150:
/* Line 670 of lalr1.cc  */
#line 621 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) = CallBack::UNHIGHLITECB;}
    break;

  case 151:
/* Line 670 of lalr1.cc  */
#line 622 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) = CallBack::MOVEBEGINCB;}
    break;

  case 152:
/* Line 670 of lalr1.cc  */
#line 623 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) = CallBack::MOVECB;}
    break;

  case 153:
/* Line 670 of lalr1.cc  */
#line 624 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) = CallBack::MOVEENDCB;}
    break;

  case 154:
/* Line 670 of lalr1.cc  */
#line 625 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) = CallBack::EDITBEGINCB;}
    break;

  case 155:
/* Line 670 of lalr1.cc  */
#line 626 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) = CallBack::EDITCB;}
    break;

  case 156:
/* Line 670 of lalr1.cc  */
#line 627 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) = CallBack::EDITENDCB;}
    break;

  case 157:
/* Line 670 of lalr1.cc  */
#line 628 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) = CallBack::ROTATEBEGINCB;}
    break;

  case 158:
/* Line 670 of lalr1.cc  */
#line 629 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) = CallBack::ROTATECB;}
    break;

  case 159:
/* Line 670 of lalr1.cc  */
#line 630 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) = CallBack::ROTATEENDCB;}
    break;

  case 160:
/* Line 670 of lalr1.cc  */
#line 631 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) = CallBack::DELETECB;}
    break;

  case 161:
/* Line 670 of lalr1.cc  */
#line 632 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) = CallBack::TEXTCB;}
    break;

  case 162:
/* Line 670 of lalr1.cc  */
#line 633 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) = CallBack::COLORCB;}
    break;

  case 163:
/* Line 670 of lalr1.cc  */
#line 634 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) = CallBack::LINEWIDTHCB;}
    break;

  case 164:
/* Line 670 of lalr1.cc  */
#line 635 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) = CallBack::PROPERTYCB;}
    break;

  case 165:
/* Line 670 of lalr1.cc  */
#line 636 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) = CallBack::FONTCB;}
    break;

  case 166:
/* Line 670 of lalr1.cc  */
#line 637 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) = CallBack::KEYCB;}
    break;

  case 167:
/* Line 670 of lalr1.cc  */
#line 638 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) = CallBack::UPDATECB;}
    break;

  case 170:
/* Line 670 of lalr1.cc  */
#line 646 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  setProps(&globalProps,(yysemantic_stack_[(3) - (1)].integer),(yysemantic_stack_[(3) - (3)].integer));
	  setProps(&localProps,(yysemantic_stack_[(3) - (1)].integer),(yysemantic_stack_[(3) - (3)].integer));
	}
    break;

  case 171:
/* Line 670 of lalr1.cc  */
#line 651 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  strncpy(globalColor,(yysemantic_stack_[(3) - (3)].str),16);
	  strncpy(localColor,(yysemantic_stack_[(3) - (3)].str),16);
	}
    break;

  case 172:
/* Line 670 of lalr1.cc  */
#line 656 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  globalDash[0] = localDash[0] =(yysemantic_stack_[(4) - (3)].integer);
	  globalDash[1] = localDash[1] =(yysemantic_stack_[(4) - (4)].integer);
        }
    break;

  case 173:
/* Line 670 of lalr1.cc  */
#line 660 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {globalWidth = localWidth = (yysemantic_stack_[(3) - (3)].integer);}
    break;

  case 174:
/* Line 670 of lalr1.cc  */
#line 662 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  strncpy(globalFont,(yysemantic_stack_[(3) - (3)].str),32);
	  strncpy(localFont,(yysemantic_stack_[(3) - (3)].str),32);
	}
    break;

  case 175:
/* Line 670 of lalr1.cc  */
#line 667 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  strncpy(globalText,(yysemantic_stack_[(3) - (3)].str),80);
	  strncpy(localText,(yysemantic_stack_[(3) - (3)].str),80);
	}
    break;

  case 176:
/* Line 670 of lalr1.cc  */
#line 672 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  setProps(&globalProps,Marker::DASH,1);
	  setProps(&localProps,Marker::DASH,1);
	}
    break;

  case 177:
/* Line 670 of lalr1.cc  */
#line 677 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  setProps(&globalProps,Marker::SOURCE,1);
	  setProps(&localProps,Marker::SOURCE,1);
	}
    break;

  case 178:
/* Line 670 of lalr1.cc  */
#line 682 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  setProps(&globalProps,Marker::SOURCE,0);
	  setProps(&localProps,Marker::SOURCE,0);
	}
    break;

  case 179:
/* Line 670 of lalr1.cc  */
#line 686 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {globalPoint = localPoint = (yysemantic_stack_[(3) - (3)].integer);}
    break;

  case 180:
/* Line 670 of lalr1.cc  */
#line 688 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  globalPoint = localPoint = (yysemantic_stack_[(4) - (3)].integer);
	  globalPointSize = localPointSize = (yysemantic_stack_[(4) - (4)].integer);
	}
    break;

  case 181:
/* Line 670 of lalr1.cc  */
#line 693 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  globalLine1 = localLine1 = (yysemantic_stack_[(4) - (3)].integer);
	  globalLine2 = localLine2 = (yysemantic_stack_[(4) - (4)].integer);
	}
    break;

  case 182:
/* Line 670 of lalr1.cc  */
#line 697 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {globalVector = localVector = (yysemantic_stack_[(3) - (3)].integer);}
    break;

  case 183:
/* Line 670 of lalr1.cc  */
#line 699 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  globalComposite = localComposite = (yysemantic_stack_[(3) - (3)].integer);
	}
    break;

  case 184:
/* Line 670 of lalr1.cc  */
#line 702 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {}
    break;

  case 185:
/* Line 670 of lalr1.cc  */
#line 704 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  strncpy(globalCompassNorth,(yysemantic_stack_[(7) - (4)].str),80);
	  strncpy(globalCompassEast,(yysemantic_stack_[(7) - (5)].str),80);
	  strncpy(localCompassNorth,(yysemantic_stack_[(7) - (4)].str),80);
	  strncpy(localCompassEast,(yysemantic_stack_[(7) - (5)].str),80);
	  globalCompassNArrow = localCompassNArrow = (yysemantic_stack_[(7) - (6)].integer);
	  globalCompassEArrow = localCompassEArrow = (yysemantic_stack_[(7) - (7)].integer);
	}
    break;

  case 186:
/* Line 670 of lalr1.cc  */
#line 712 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {globalTextAngle = localTextAngle = (yysemantic_stack_[(3) - (3)].real);}
    break;

  case 187:
/* Line 670 of lalr1.cc  */
#line 713 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {globalTextRotate = localTextRotate = (yysemantic_stack_[(3) - (3)].integer);}
    break;

  case 188:
/* Line 670 of lalr1.cc  */
#line 714 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {globalWCS = ( CoordSystem)(yysemantic_stack_[(3) - (3)].integer);}
    break;

  case 189:
/* Line 670 of lalr1.cc  */
#line 718 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  globalRulerCoordSystem = localRulerCoordSystem = ( CoordSystem)(yysemantic_stack_[(4) - (1)].integer);
	  globalRulerSkyFrame = localRulerSkyFrame = ( SkyFrame)(yysemantic_stack_[(4) - (2)].integer);
	  globalRulerDistSystem = localRulerDistSystem = ( CoordSystem)(yysemantic_stack_[(4) - (3)].integer);
	  globalRulerDistFormat = localRulerDistFormat = ( SkyDist)(yysemantic_stack_[(4) - (4)].integer);
	}
    break;

  case 190:
/* Line 670 of lalr1.cc  */
#line 725 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  globalRulerCoordSystem = localRulerCoordSystem = ( CoordSystem)(yysemantic_stack_[(2) - (1)].integer);
	  globalRulerSkyFrame = localRulerSkyFrame =  FK5;
	  globalRulerDistSystem = localRulerDistSystem = ( CoordSystem)(yysemantic_stack_[(2) - (2)].integer);
	  globalRulerDistFormat = localRulerDistFormat =  DEGREE;
	}
    break;

  case 191:
/* Line 670 of lalr1.cc  */
#line 732 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  globalRulerCoordSystem = localRulerCoordSystem = ( CoordSystem)(yysemantic_stack_[(2) - (1)].integer);
	  globalRulerSkyFrame = localRulerSkyFrame =  FK5;
	  globalRulerDistSystem = localRulerDistSystem =  WCS;
	  globalRulerDistFormat = localRulerDistFormat = ( SkyDist)(yysemantic_stack_[(2) - (2)].integer);
	}
    break;

  case 192:
/* Line 670 of lalr1.cc  */
#line 739 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  globalRulerCoordSystem = localRulerCoordSystem =  WCS;
	  globalRulerSkyFrame = localRulerSkyFrame = ( SkyFrame)(yysemantic_stack_[(2) - (1)].integer);
	  globalRulerDistSystem = localRulerDistSystem = ( CoordSystem)(yysemantic_stack_[(2) - (2)].integer);
	  globalRulerDistFormat = localRulerDistFormat =  DEGREE;
	}
    break;

  case 193:
/* Line 670 of lalr1.cc  */
#line 746 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  globalRulerCoordSystem = localRulerCoordSystem =  WCS;
	  globalRulerSkyFrame = localRulerSkyFrame = ( SkyFrame)(yysemantic_stack_[(2) - (1)].integer);
	  globalRulerDistSystem = localRulerDistSystem =  WCS;
	  globalRulerDistFormat = localRulerDistFormat = ( SkyDist)(yysemantic_stack_[(2) - (2)].integer);
	}
    break;

  case 194:
/* Line 670 of lalr1.cc  */
#line 753 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  globalRulerCoordSystem = localRulerCoordSystem =  WCS;
	  globalRulerSkyFrame = localRulerSkyFrame =  FK5;
	  globalRulerDistSystem = localRulerDistSystem = ( CoordSystem)(yysemantic_stack_[(2) - (2)].integer);
	  globalRulerDistFormat = localRulerDistFormat =  DEGREE;
	}
    break;

  case 195:
/* Line 670 of lalr1.cc  */
#line 760 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  globalRulerCoordSystem = localRulerCoordSystem =  WCS;
	  globalRulerSkyFrame = localRulerSkyFrame =  FK5;
	  globalRulerDistSystem = localRulerDistSystem =  WCS;
	  globalRulerDistFormat = localRulerDistFormat = ( SkyDist)(yysemantic_stack_[(2) - (2)].integer);
	}
    break;

  case 196:
/* Line 670 of lalr1.cc  */
#line 767 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  globalRulerCoordSystem = localRulerCoordSystem =  IMAGE;
	  globalRulerSkyFrame = localRulerSkyFrame =  FK5;
	  globalRulerDistSystem = localRulerDistSystem =  WCS;
	  globalRulerDistFormat = localRulerDistFormat = ( SkyDist)(yysemantic_stack_[(1) - (1)].integer);
	}
    break;

  case 197:
/* Line 670 of lalr1.cc  */
#line 774 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  globalRulerCoordSystem = localRulerCoordSystem =  IMAGE;
	  globalRulerSkyFrame = localRulerSkyFrame =  FK5;
	  globalRulerDistSystem = localRulerDistSystem =  IMAGE;
	  globalRulerDistFormat = localRulerDistFormat =  DEGREE;
	}
    break;

  case 198:
/* Line 670 of lalr1.cc  */
#line 783 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  globalCompassCoordSystem = localCompassCoordSystem = ( CoordSystem)(yysemantic_stack_[(2) - (1)].integer);
	  globalCompassSkyFrame = localCompassSkyFrame = ( SkyFrame)(yysemantic_stack_[(2) - (2)].integer);
	}
    break;

  case 199:
/* Line 670 of lalr1.cc  */
#line 788 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  globalCompassCoordSystem = localCompassCoordSystem = ( CoordSystem)(yysemantic_stack_[(1) - (1)].integer);
	  globalCompassSkyFrame = localCompassSkyFrame =  FK5;
	}
    break;

  case 200:
/* Line 670 of lalr1.cc  */
#line 793 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  globalCompassCoordSystem = localCompassCoordSystem =  WCS;
	  globalCompassSkyFrame = localCompassSkyFrame = ( SkyFrame)(yysemantic_stack_[(1) - (1)].integer);
	}
    break;

  case 201:
/* Line 670 of lalr1.cc  */
#line 798 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  globalCompassCoordSystem = localCompassCoordSystem =  WCS;
	  globalCompassSkyFrame = localCompassSkyFrame =  FK5;
	}
    break;

  case 202:
/* Line 670 of lalr1.cc  */
#line 804 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  // global properties
	  globalSystem =  PHYSICAL;
	  globalWCS = WCS;
	  globalSky = NATIVEWCS;
	  globalTile = 1;
	  globalProps =
	    Marker::SELECT | Marker::EDIT | Marker::MOVE |
	    Marker::ROTATE | Marker::DELETE | Marker::HIGHLITE |
	    Marker::INCLUDE | Marker::SOURCE;
	  strcpy(globalColor,"green");
	  globalDash[0] = 8;
	  globalDash[1] = 3;
          globalWidth = 1;
	  strcpy(globalFont,"helvetica 10 normal roman");
	  strcpy(globalText,"");

	  // unique properties
	  globalLine1 = 0;
	  globalLine2 = 0;
	  globalVector = 1;
	  globalComposite = 1;
	  globalRulerCoordSystem =  PHYSICAL;
	  globalRulerSkyFrame =  FK5;
	  globalRulerDistSystem =  PHYSICAL;
	  globalRulerDistFormat =  DEGREE;
	  globalCompassCoordSystem =  PHYSICAL;
	  globalCompassSkyFrame =  FK5;
	  strcpy(globalCompassNorth,"N");
	  strcpy(globalCompassEast,"E");
	  globalCompassNArrow = 1;
	  globalCompassEArrow = 1;
	  globalPoint = BOXCIRCLE;
	  globalPointSize = POINTSIZE;
	  globalTextAngle=0;
	  globalTextRotate=1;

	  aStatus = 0;
	  cStatus = 0;
	}
    break;

  case 205:
/* Line 670 of lalr1.cc  */
#line 850 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {setProps(&localProps,(yysemantic_stack_[(3) - (1)].integer),(yysemantic_stack_[(3) - (3)].integer));}
    break;

  case 206:
/* Line 670 of lalr1.cc  */
#line 851 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {strncpy(localColor,(yysemantic_stack_[(3) - (3)].str),16);}
    break;

  case 207:
/* Line 670 of lalr1.cc  */
#line 853 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  localDash[0] =(yysemantic_stack_[(4) - (3)].integer);
	  localDash[1] =(yysemantic_stack_[(4) - (4)].integer);
        }
    break;

  case 208:
/* Line 670 of lalr1.cc  */
#line 857 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {localWidth = (yysemantic_stack_[(3) - (3)].integer);}
    break;

  case 209:
/* Line 670 of lalr1.cc  */
#line 858 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {strncpy(localFont,(yysemantic_stack_[(3) - (3)].str),32);}
    break;

  case 210:
/* Line 670 of lalr1.cc  */
#line 859 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {strncpy(localText,(yysemantic_stack_[(3) - (3)].str),80);}
    break;

  case 211:
/* Line 670 of lalr1.cc  */
#line 860 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {taglist.push_back((yysemantic_stack_[(3) - (3)].str));}
    break;

  case 212:
/* Line 670 of lalr1.cc  */
#line 861 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {/*cblist.append(
	    new CallBack(fr->getInterp(),(CallBack::Type)$3,$4,$5));*/}
    break;

  case 213:
/* Line 670 of lalr1.cc  */
#line 863 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {setProps(&localProps,Marker::DASH,1);}
    break;

  case 214:
/* Line 670 of lalr1.cc  */
#line 864 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {setProps(&localProps,Marker::SOURCE,1);}
    break;

  case 215:
/* Line 670 of lalr1.cc  */
#line 865 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {setProps(&localProps,Marker::SOURCE,0);}
    break;

  case 216:
/* Line 670 of lalr1.cc  */
#line 867 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {localPoint = (yysemantic_stack_[(3) - (3)].integer);}
    break;

  case 217:
/* Line 670 of lalr1.cc  */
#line 868 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {localPoint = (yysemantic_stack_[(4) - (3)].integer); localPointSize = (yysemantic_stack_[(4) - (4)].integer);}
    break;

  case 218:
/* Line 670 of lalr1.cc  */
#line 869 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {localLine1=(yysemantic_stack_[(4) - (3)].integer); localLine2=(yysemantic_stack_[(4) - (4)].integer);}
    break;

  case 219:
/* Line 670 of lalr1.cc  */
#line 870 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {localVector=(yysemantic_stack_[(3) - (3)].integer);}
    break;

  case 220:
/* Line 670 of lalr1.cc  */
#line 871 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {localComposite=(yysemantic_stack_[(3) - (3)].integer);}
    break;

  case 222:
/* Line 670 of lalr1.cc  */
#line 874 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  strncpy(localCompassNorth,(yysemantic_stack_[(7) - (4)].str),80);
	  strncpy(localCompassEast,(yysemantic_stack_[(7) - (5)].str),80);
	  localCompassNArrow = (yysemantic_stack_[(7) - (6)].integer);
	  localCompassEArrow = (yysemantic_stack_[(7) - (7)].integer);
	}
    break;

  case 223:
/* Line 670 of lalr1.cc  */
#line 880 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {localTextAngle=(yysemantic_stack_[(3) - (3)].real);}
    break;

  case 224:
/* Line 670 of lalr1.cc  */
#line 881 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {localTextRotate=(yysemantic_stack_[(3) - (3)].integer);}
    break;

  case 228:
/* Line 670 of lalr1.cc  */
#line 888 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  localRulerCoordSystem = ( CoordSystem)(yysemantic_stack_[(4) - (1)].integer);
	  localRulerSkyFrame = ( SkyFrame)(yysemantic_stack_[(4) - (2)].integer);
	  localRulerDistSystem = ( CoordSystem)(yysemantic_stack_[(4) - (3)].integer);
	  localRulerDistFormat = ( SkyDist)(yysemantic_stack_[(4) - (4)].integer);
	}
    break;

  case 229:
/* Line 670 of lalr1.cc  */
#line 895 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  localRulerCoordSystem = ( CoordSystem)(yysemantic_stack_[(2) - (1)].integer);
	  localRulerSkyFrame =  FK5;
	  localRulerDistSystem = ( CoordSystem)(yysemantic_stack_[(2) - (2)].integer);
	  localRulerDistFormat =  DEGREE;
	}
    break;

  case 230:
/* Line 670 of lalr1.cc  */
#line 902 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  localRulerCoordSystem = ( CoordSystem)(yysemantic_stack_[(2) - (1)].integer);
	  localRulerSkyFrame =  FK5;
	  localRulerDistSystem =  WCS;
	  localRulerDistFormat = ( SkyDist)(yysemantic_stack_[(2) - (2)].integer);
	}
    break;

  case 231:
/* Line 670 of lalr1.cc  */
#line 909 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  localRulerCoordSystem =  WCS;
	  localRulerSkyFrame = ( SkyFrame)(yysemantic_stack_[(2) - (1)].integer);
	  localRulerDistSystem = ( CoordSystem)(yysemantic_stack_[(2) - (2)].integer);
	  localRulerDistFormat =  DEGREE;
	}
    break;

  case 232:
/* Line 670 of lalr1.cc  */
#line 916 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  localRulerCoordSystem =  WCS;
	  localRulerSkyFrame = ( SkyFrame)(yysemantic_stack_[(2) - (1)].integer);
	  localRulerDistSystem =  WCS;
	  localRulerDistFormat = ( SkyDist)(yysemantic_stack_[(2) - (2)].integer);
	}
    break;

  case 233:
/* Line 670 of lalr1.cc  */
#line 923 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  localRulerCoordSystem =  WCS;
	  localRulerSkyFrame =  FK5;
	  localRulerDistSystem = ( CoordSystem)(yysemantic_stack_[(2) - (2)].integer);
	  localRulerDistFormat =  DEGREE;
	}
    break;

  case 234:
/* Line 670 of lalr1.cc  */
#line 930 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  localRulerCoordSystem =  WCS;
	  localRulerSkyFrame =  FK5;
	  localRulerDistSystem =  WCS;
	  localRulerDistFormat = ( SkyDist)(yysemantic_stack_[(2) - (2)].integer);
	}
    break;

  case 235:
/* Line 670 of lalr1.cc  */
#line 937 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  localRulerCoordSystem =  IMAGE;
	  localRulerSkyFrame =  FK5;
	  localRulerDistSystem =  WCS;
	  localRulerDistFormat = ( SkyDist)(yysemantic_stack_[(1) - (1)].integer);
	}
    break;

  case 236:
/* Line 670 of lalr1.cc  */
#line 944 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  localRulerCoordSystem =  IMAGE;
	  localRulerSkyFrame =  FK5;
	  localRulerDistSystem =  IMAGE;
	  localRulerDistFormat =  DEGREE;
	}
    break;

  case 237:
/* Line 670 of lalr1.cc  */
#line 953 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  localCompassCoordSystem = ( CoordSystem)(yysemantic_stack_[(2) - (1)].integer);
	  localCompassSkyFrame = ( SkyFrame)(yysemantic_stack_[(2) - (2)].integer);
	}
    break;

  case 238:
/* Line 670 of lalr1.cc  */
#line 958 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  localCompassCoordSystem = ( CoordSystem)(yysemantic_stack_[(1) - (1)].integer);
	  localCompassSkyFrame =  FK5;
	}
    break;

  case 239:
/* Line 670 of lalr1.cc  */
#line 963 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  localCompassCoordSystem =  WCS;
	  localCompassSkyFrame = ( SkyFrame)(yysemantic_stack_[(1) - (1)].integer);
	}
    break;

  case 240:
/* Line 670 of lalr1.cc  */
#line 968 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  localCompassCoordSystem =  WCS;
	  localCompassSkyFrame =  FK5;
	}
    break;

  case 241:
/* Line 670 of lalr1.cc  */
#line 974 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {aNum=0; aAngNum=0;}
    break;

  case 242:
/* Line 670 of lalr1.cc  */
#line 974 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {localCpanda = 2;}
    break;

  case 243:
/* Line 670 of lalr1.cc  */
#line 975 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {localCpanda=0;}
    break;

  case 244:
/* Line 670 of lalr1.cc  */
#line 978 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {aNum=0; aAngNum=0, aAngle=0;}
    break;

  case 245:
/* Line 670 of lalr1.cc  */
#line 979 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {aAngle=(yysemantic_stack_[(10) - (9)].real);localEpanda=2;}
    break;

  case 246:
/* Line 670 of lalr1.cc  */
#line 980 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {localEpanda=0;}
    break;

  case 247:
/* Line 670 of lalr1.cc  */
#line 983 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {aNum=0; aAngNum=0, aAngle=0;}
    break;

  case 248:
/* Line 670 of lalr1.cc  */
#line 984 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {aAngle=(yysemantic_stack_[(10) - (9)].real);localBpanda=2;}
    break;

  case 249:
/* Line 670 of lalr1.cc  */
#line 985 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {localBpanda=0;}
    break;

  case 250:
/* Line 670 of lalr1.cc  */
#line 988 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  // reset maperr flag
	  //maperr = 0;

	  // needed for annulus, ellipse annulus, and box annulus
	  aNum = 2;

	  // composite (previous conjuction found?)
	  if (!cStatus) fr->resetCompositeMarker();

	  // global properties
	  localSystem = globalSystem;
	  localSky = globalSky;
	  localProps = globalProps;
	  strcpy(localColor,globalColor);
	  localDash[0] = globalDash[0];
	  localDash[1] = globalDash[1];
	  localWidth = globalWidth;
	  strcpy(localFont,globalFont);
	  strcpy(localText,globalText);
	  strcpy(localComment,"");
	  taglist.clear();
	  cblist.clear();

	  // unique properties
	  localLine1 = globalLine1;
	  localLine2 = globalLine2;
	  localVector = globalVector;
	  localComposite = globalComposite;
	  localPoint = globalPoint;
	  localPointSize = globalPointSize;
	  localRulerCoordSystem = globalRulerCoordSystem;
	  localRulerSkyFrame = globalRulerSkyFrame;
	  localRulerDistSystem = globalRulerDistSystem;
	  localRulerDistFormat = globalRulerDistFormat;
	  localCompassCoordSystem = globalCompassCoordSystem;
	  localCompassSkyFrame = globalCompassSkyFrame;
	  strcpy(localCompassNorth,globalCompassNorth);
	  strcpy(localCompassEast,globalCompassEast);
	  localCompassNArrow = globalCompassNArrow;
	  localCompassEArrow = globalCompassEArrow;
	  localTextAngle = globalTextAngle;
	  localTextRotate = globalTextRotate;
	  localCpanda = 1;
	  localEpanda = 1;
	  localBpanda = 1;
	}
    break;

  case 251:
/* Line 670 of lalr1.cc  */
#line 1037 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) = CIRCLE;}
    break;

  case 252:
/* Line 670 of lalr1.cc  */
#line 1038 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) = BOX;}
    break;

  case 253:
/* Line 670 of lalr1.cc  */
#line 1039 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) = DIAMOND;}
    break;

  case 254:
/* Line 670 of lalr1.cc  */
#line 1040 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) = CROSS;}
    break;

  case 255:
/* Line 670 of lalr1.cc  */
#line 1041 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) = XPT;}
    break;

  case 256:
/* Line 670 of lalr1.cc  */
#line 1042 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) = ARROW;}
    break;

  case 257:
/* Line 670 of lalr1.cc  */
#line 1043 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {(yyval.integer) = BOXCIRCLE;}
    break;

  case 258:
/* Line 670 of lalr1.cc  */
#line 1046 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {setProps(&localProps, Marker::INCLUDE, 1);}
    break;

  case 259:
/* Line 670 of lalr1.cc  */
#line 1047 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {setProps(&localProps, Marker::INCLUDE, 0);}
    break;

  case 260:
/* Line 670 of lalr1.cc  */
#line 1051 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {fr->createTextCmd(coordtovec((yysemantic_stack_[(6) - (3)].vector)),
        localTextAngle,localTextRotate,
        localColor,localDash,localWidth,localFont,
        localText,localProps,localComment,taglist /*,cblist*/);}
    break;

  case 261:
/* Line 670 of lalr1.cc  */
#line 1056 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {fr->createCompositeCmd(coordtovec((yysemantic_stack_[(8) - (3)].vector)),
        (yysemantic_stack_[(8) - (5)].real), localComposite,
        localColor,localDash,localWidth,localFont,
        localText,localProps,localComment,taglist /*,cblist*/);}
    break;

  case 262:
/* Line 670 of lalr1.cc  */
#line 1061 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {fr->createVectCmd(coordtovec((yysemantic_stack_[(10) - (3)].vector)),
        (yysemantic_stack_[(10) - (5)].real),(yysemantic_stack_[(10) - (7)].real),
        localVector,
        localColor,localDash,localWidth,localFont,
        localText,localProps,localComment,taglist /*,cblist*/);}
    break;

  case 263:
/* Line 670 of lalr1.cc  */
#line 1067 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
      // hard coded into projection.tcl
      fr->createProjectionCmd(coordtovec((yysemantic_stack_[(10) - (3)].vector)),
        coordtovec((yysemantic_stack_[(10) - (5)].vector)),
        (yysemantic_stack_[(10) - (7)].real),
        "ProjectionPlotCB", "ProjectionPlotDeleteCB",
        localColor,localDash,localWidth,localFont,
        localText,localProps,localComment,taglist /*,cblist*/);
    }
    break;

  case 264:
/* Line 670 of lalr1.cc  */
#line 1077 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  fr->createRulerCmd(coordtovec((yysemantic_stack_[(8) - (3)].vector)),
	  coordtovec((yysemantic_stack_[(8) - (5)].vector)),
   	  localRulerCoordSystem, localRulerSkyFrame,
	  localRulerDistSystem, localRulerDistFormat,
	  localColor,localDash,localWidth,localFont,
	  localText,localProps,localComment,taglist/*,cblist*/);
	}
    break;

  case 265:
/* Line 670 of lalr1.cc  */
#line 1086 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  fr->createCompassCmd(coordtovec((yysemantic_stack_[(8) - (3)].vector)), 
	  (yysemantic_stack_[(8) - (5)].real),
	  localCompassNorth, localCompassEast, 
	  localCompassNArrow, localCompassEArrow,
   	  localCompassCoordSystem, localCompassSkyFrame,
	  localColor,localDash,localWidth,localFont,
	  localText,localProps,localComment,taglist/*,cblist*/);
	}
    break;

  case 266:
/* Line 670 of lalr1.cc  */
#line 1097 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  // backward compatibility
	  fr->createCircleCmd(coordtovec((yysemantic_stack_[(8) - (3)].vector)),
	  (yysemantic_stack_[(8) - (5)].real),
	  localColor,localDash,localWidth,localFont,
	  localText,localProps,localComment,taglist/*,cblist*/);
	}
    break;

  case 267:
/* Line 670 of lalr1.cc  */
#line 1107 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  fr->createCircleCmd(coordtovec((yysemantic_stack_[(8) - (3)].vector)),
	  (yysemantic_stack_[(8) - (5)].real),
	  localColor,localDash,localWidth,localFont,
	  localText,localProps,localComment,taglist/*,cblist*/);
	}
    break;

  case 268:
/* Line 670 of lalr1.cc  */
#line 1114 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  // backwards compatibility
	  fr->createCircleCmd(coordtovec((yysemantic_stack_[(8) - (3)].vector)),
	  (yysemantic_stack_[(8) - (5)].real),
	  localColor,localDash,localWidth,localFont,
	  localText,localProps,localComment,taglist/*,cblist*/);
	}
    break;

  case 269:
/* Line 670 of lalr1.cc  */
#line 1122 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  // for ellipse annulus
	  aStatus = 1;
	  aCenter = coordtovec((yysemantic_stack_[(10) - (3)].vector));
	  aAngles[0] = (yysemantic_stack_[(10) - (7)].real);
	  aVector[0] = coordtovec((yysemantic_stack_[(10) - (5)].vector));
	  aNumsao = 1;
	  strncpy(aColor,localColor,16);
	  aDash[0] = localDash[0];
	  aDash[1] = localDash[1];
	  aWidth = localWidth;
	  strncpy(aFont,localFont,32);
	  strncpy(aText,localText,80);
	  strncpy(aComment,localComment,80);
	  aProps = localProps;

	  fr->createEllipseCmd(coordtovec((yysemantic_stack_[(10) - (3)].vector)),
	  coordtovec((yysemantic_stack_[(10) - (5)].vector)),
	  (yysemantic_stack_[(10) - (7)].real),
	  localColor,localDash,localWidth,localFont,
	  localText,localProps,localComment,taglist/*,cblist*/);
	}
    break;

  case 270:
/* Line 670 of lalr1.cc  */
#line 1145 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  // for box annulus
	  aStatus = 3;
	  aCenter = coordtovec((yysemantic_stack_[(10) - (3)].vector));
	  aAngles[0] = (yysemantic_stack_[(10) - (7)].real);
	  aVector[0] = coordtovec((yysemantic_stack_[(10) - (5)].vector));
	  aNumsao = 1;
	  strncpy(aColor,localColor,16);
	  aDash[0] = localDash[0];
	  aDash[1] = localDash[1];
	  aWidth = localWidth;
	  strncpy(aFont,localFont,32);
	  strncpy(aText,localText,80);
	  strncpy(aComment,localComment,80);
	  aProps = localProps;

	  fr->createBoxCmd(coordtovec((yysemantic_stack_[(10) - (3)].vector)),
	  coordtovec((yysemantic_stack_[(10) - (5)].vector)),
	  (yysemantic_stack_[(10) - (7)].real),
	  localColor,localDash,localWidth,localFont,
	  localText,localProps,localComment,taglist/*,cblist*/);
	}
    break;

  case 271:
/* Line 670 of lalr1.cc  */
#line 1168 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  // backwards compatibility
	  fr->createBoxCmd(coordtovec((yysemantic_stack_[(10) - (3)].vector)),
	  coordtovec((yysemantic_stack_[(10) - (5)].vector)),
	  (yysemantic_stack_[(10) - (7)].real),
	  localColor,localDash,localWidth,localFont,
	  localText,localProps,localComment,taglist/*,cblist*/);
	}
    break;

  case 272:
/* Line 670 of lalr1.cc  */
#line 1176 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {polylist.clear();}
    break;

  case 273:
/* Line 670 of lalr1.cc  */
#line 1178 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  fr->createPolygonCmd(polylist, 
	  localColor,localDash,localWidth,localFont,
	  localText,localProps,localComment,taglist/*,cblist*/);
	}
    break;

  case 274:
/* Line 670 of lalr1.cc  */
#line 1183 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {polylist.clear();}
    break;

  case 275:
/* Line 670 of lalr1.cc  */
#line 1185 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  fr->createSegmentCmd(polylist, 
	  localColor,localDash,localWidth,localFont,
	  localText,localProps,localComment,taglist/*,cblist*/);
	}
    break;

  case 276:
/* Line 670 of lalr1.cc  */
#line 1192 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  fr->createLineCmd(coordtovec((yysemantic_stack_[(8) - (3)].vector)),
	  coordtovec((yysemantic_stack_[(8) - (5)].vector)),
	  localLine1,localLine2,
	  localColor,localDash,localWidth,localFont,
	  localText,localProps,localComment,taglist/*,cblist*/);
	}
    break;

  case 277:
/* Line 670 of lalr1.cc  */
#line 1200 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  fr->createVectCmd(coordtovec((yysemantic_stack_[(10) - (3)].vector)),
	  (yysemantic_stack_[(10) - (5)].real),(yysemantic_stack_[(10) - (7)].real),
	  localVector,
	  localColor,localDash,localWidth,localFont,
	  localText,localProps,localComment,taglist/*,cblist*/);
	}
    break;

  case 278:
/* Line 670 of lalr1.cc  */
#line 1208 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  fr->createTextCmd(coordtovec((yysemantic_stack_[(6) - (3)].vector)),
	   localTextAngle,localTextRotate,
	   localColor,localDash,localWidth,localFont,
	   localText,localProps,localComment,taglist/*,cblist*/);
	}
    break;

  case 279:
/* Line 670 of lalr1.cc  */
#line 1214 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {strncpy(localText,(yysemantic_stack_[(6) - (5)].str),80);}
    break;

  case 280:
/* Line 670 of lalr1.cc  */
#line 1216 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  fr->createTextCmd(coordtovec((yysemantic_stack_[(9) - (3)].vector)),
	  localTextAngle,localTextRotate,
	  localColor,localDash,localWidth,localFont,
	  localText,localProps,localComment,taglist/*,cblist*/);
	}
    break;

  case 281:
/* Line 670 of lalr1.cc  */
#line 1223 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  fr->createPointCmd(coordtovec((yysemantic_stack_[(6) - (3)].vector)), 
	  (PointShape)localPoint, localPointSize, 
	  localColor,localDash,localWidth,localFont,
	  localText,localProps,localComment,taglist/*,cblist*/);
	}
    break;

  case 282:
/* Line 670 of lalr1.cc  */
#line 1231 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  fr->createRulerCmd(coordtovec((yysemantic_stack_[(8) - (3)].vector)),
	  coordtovec((yysemantic_stack_[(8) - (5)].vector)),
   	  localRulerCoordSystem, localRulerSkyFrame,
	  localRulerDistSystem, localRulerDistFormat,
	  localColor,localDash,localWidth,localFont,
	  localText,localProps,localComment,taglist/*,cblist*/);
	}
    break;

  case 283:
/* Line 670 of lalr1.cc  */
#line 1240 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  fr->createCompassCmd(coordtovec((yysemantic_stack_[(8) - (3)].vector)), 
	  (yysemantic_stack_[(8) - (5)].real),
	  localCompassNorth, localCompassEast, 
	  localCompassNArrow, localCompassEArrow,
   	  localCompassCoordSystem, localCompassSkyFrame,
	  localColor,localDash,localWidth,localFont,
	  localText,localProps,localComment,taglist/*,cblist*/);
	}
    break;

  case 284:
/* Line 670 of lalr1.cc  */
#line 1250 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  fr->createProjectionCmd(coordtovec((yysemantic_stack_[(10) - (3)].vector)),
	  coordtovec((yysemantic_stack_[(10) - (5)].vector)),
	  (yysemantic_stack_[(10) - (7)].real),
	  "ProjectionPlotCB", "ProjectionPlotDeleteCB",
	  localColor,localDash,localWidth,localFont,
	  localText,localProps,localComment,taglist/*,cblist*/);
	}
    break;

  case 285:
/* Line 670 of lalr1.cc  */
#line 1259 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  fr->createAnnulusCmd(coordtovec((yysemantic_stack_[(10) - (3)].vector)),
	  (yysemantic_stack_[(10) - (5)].real),(yysemantic_stack_[(10) - (7)].real),1,
	  localColor,localDash,localWidth,localFont,
	  localText,localProps,localComment,taglist/*,cblist*/);
	}
    break;

  case 286:
/* Line 670 of lalr1.cc  */
#line 1267 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  aAnnuli[0] = (yysemantic_stack_[(12) - (5)].real);
	  aAnnuli[1] = (yysemantic_stack_[(12) - (7)].real);
	  fr->createAnnulusCmd(coordtovec((yysemantic_stack_[(12) - (3)].vector)),
	    aNum,aAnnuli,
	    localColor,localDash,localWidth,localFont,
	    localText,localProps,localComment,taglist/*,cblist*/);
	}
    break;

  case 287:
/* Line 670 of lalr1.cc  */
#line 1277 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  fr->createAnnulusCmd(coordtovec((yysemantic_stack_[(12) - (3)].vector)),
	  (yysemantic_stack_[(12) - (5)].real),(yysemantic_stack_[(12) - (7)].real),(yysemantic_stack_[(12) - (9)].integer),
	  localColor,localDash,localWidth,localFont,
	  localText,localProps,localComment,taglist/*,cblist*/);
	}
    break;

  case 288:
/* Line 670 of lalr1.cc  */
#line 1285 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  // prefered syntax
	  fr->createEllipseAnnulusCmd(coordtovec((yysemantic_stack_[(12) - (3)].vector)),
	    coordtovec((yysemantic_stack_[(12) - (5)].vector)),coordtovec((yysemantic_stack_[(12) - (7)].vector)),1,
	    (yysemantic_stack_[(12) - (9)].real),
	    localColor,localDash,localWidth,localFont,
	    localText,localProps,localComment,taglist/*,cblist*/);
	}
    break;

  case 289:
/* Line 670 of lalr1.cc  */
#line 1295 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  // prefered syntax
	  fr->createEllipseAnnulusCmd(coordtovec((yysemantic_stack_[(14) - (3)].vector)),
	    coordtovec((yysemantic_stack_[(14) - (5)].vector)),coordtovec((yysemantic_stack_[(14) - (7)].vector)),(yysemantic_stack_[(14) - (9)].integer),
	    (yysemantic_stack_[(14) - (11)].real),
	    localColor,localDash,localWidth,localFont,
	    localText,localProps,localComment,taglist/*,cblist*/);
	}
    break;

  case 290:
/* Line 670 of lalr1.cc  */
#line 1305 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  // prefered syntax
	  aVector[0] = coordtovec((yysemantic_stack_[(14) - (5)].vector));
	  aVector[1] = coordtovec((yysemantic_stack_[(14) - (7)].vector));
	  fr->createEllipseAnnulusCmd(coordtovec((yysemantic_stack_[(14) - (3)].vector)),
	    aNum,aVector,
	    (yysemantic_stack_[(14) - (11)].real),
	    localColor,localDash,localWidth,localFont,
	    localText,localProps,localComment,taglist/*,cblist*/);
	}
    break;

  case 291:
/* Line 670 of lalr1.cc  */
#line 1317 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {	
	  // backwards compatibility
	  // old saoimage syntax
	  aStatus = 2;
	  aVector[aNumsao++] = coordtovec((yysemantic_stack_[(18) - (5)].vector));
	}
    break;

  case 292:
/* Line 670 of lalr1.cc  */
#line 1325 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  // prefered syntax
	  fr->createBoxAnnulusCmd(coordtovec((yysemantic_stack_[(12) - (3)].vector)),
	    coordtovec((yysemantic_stack_[(12) - (5)].vector)),coordtovec((yysemantic_stack_[(12) - (7)].vector)),1,
	    (yysemantic_stack_[(12) - (9)].real),
	    localColor,localDash,localWidth,localFont,
	    localText,localProps,localComment,taglist/*,cblist*/);
	}
    break;

  case 293:
/* Line 670 of lalr1.cc  */
#line 1339 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  // prefered syntax
	  fr->createBoxAnnulusCmd(coordtovec((yysemantic_stack_[(14) - (3)].vector)),
	    aNum, aVector,
	    (yysemantic_stack_[(14) - (11)].real),
	    localColor,localDash,localWidth,localFont,
	    localText,localProps,localComment,taglist/*,cblist*/);
	}
    break;

  case 294:
/* Line 670 of lalr1.cc  */
#line 1349 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {	
	  // backwards compatibility
          // old saoimage syntax
	  aStatus = 4;
	  aVector[aNumsao++] = coordtovec((yysemantic_stack_[(18) - (5)].vector));
	}
    break;

  case 295:
/* Line 670 of lalr1.cc  */
#line 1358 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  switch (localCpanda) {
	  case 0: /* ignore it */
	    break;
	  case 1: /* normal cpanda */
	    fr->createCpandaCmd(coordtovec((yysemantic_stack_[(18) - (3)].vector)),
	      (yysemantic_stack_[(18) - (5)].real),(yysemantic_stack_[(18) - (7)].real),(yysemantic_stack_[(18) - (9)].integer),
	      (yysemantic_stack_[(18) - (11)].real),(yysemantic_stack_[(18) - (13)].real),(yysemantic_stack_[(18) - (15)].integer),
	      localColor,localDash,localWidth,localFont,
	      localText,localProps,localComment,taglist/*,cblist*/);
	    break;
	  case 2: /* one of our special pandas */
	    fr->createCpandaCmd(coordtovec((yysemantic_stack_[(18) - (3)].vector)),
	      aAngNum,aAngles,
	      aNum,aAnnuli,
	      localColor,localDash,localWidth,localFont,
	      localText,localProps,localComment,taglist/*,cblist*/);
	    break;
	  }
	}
    break;

  case 296:
/* Line 670 of lalr1.cc  */
#line 1380 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  switch (localEpanda) {
	  case 0: /* ignore it */
	    break;
	  case 1: /* normal epanda */
	    fr->createEpandaCmd(coordtovec((yysemantic_stack_[(20) - (3)].vector)),
	      (yysemantic_stack_[(20) - (5)].real),(yysemantic_stack_[(20) - (7)].real),(yysemantic_stack_[(20) - (9)].integer),
	      coordtovec((yysemantic_stack_[(20) - (11)].vector)),coordtovec((yysemantic_stack_[(20) - (13)].vector)),(yysemantic_stack_[(20) - (15)].integer),
	      (yysemantic_stack_[(20) - (17)].real),
	      localColor,localDash,localWidth,localFont,
	      localText,localProps,localComment,taglist/*,cblist*/);
	    break;
	  case 2: /* one of our special pandas */
	    fr->createEpandaCmd(coordtovec((yysemantic_stack_[(20) - (3)].vector)),
	      aAngNum,aAngles,
	      aNum,aVector,
	      aAngle,
	      localColor,localDash,localWidth,localFont,
	      localText,localProps,localComment,taglist/*,cblist*/);
	    break;
	  }
	}
    break;

  case 297:
/* Line 670 of lalr1.cc  */
#line 1404 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  switch (localBpanda) {
	  case 0: /* ignore it */
	    break;
	  case 1: /* normal bpanda */
	    fr->createBpandaCmd(coordtovec((yysemantic_stack_[(20) - (3)].vector)),
	      (yysemantic_stack_[(20) - (5)].real),(yysemantic_stack_[(20) - (7)].real),(yysemantic_stack_[(20) - (9)].integer),
	      coordtovec((yysemantic_stack_[(20) - (11)].vector)),coordtovec((yysemantic_stack_[(20) - (13)].vector)),(yysemantic_stack_[(20) - (15)].integer),
	      (yysemantic_stack_[(20) - (17)].real),
	      localColor,localDash,localWidth,localFont,
	      localText,localProps,localComment,taglist/*,cblist*/);
	    break;
	  case 2: /* one of our special pandas */
	    fr->createBpandaCmd(coordtovec((yysemantic_stack_[(20) - (3)].vector)),
	      aAngNum,aAngles,
	      aNum,aVector,
	      aAngle,
	      localColor,localDash,localWidth,localFont,
	      localText,localProps,localComment,taglist/*,cblist*/);
	    break;
	  }
	}
    break;

  case 302:
/* Line 670 of lalr1.cc  */
#line 1434 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  fr->createCompositeCmd(coordtovec((yysemantic_stack_[(8) - (3)].vector)),
	  (yysemantic_stack_[(8) - (5)].real), localComposite,
	  localColor,localDash,localWidth,localFont,
	  localText,localProps,localComment,taglist/*,cblist*/);
	}
    break;

  case 305:
/* Line 670 of lalr1.cc  */
#line 1446 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {polylist.push_back(coordtovec((yysemantic_stack_[(1) - (1)].vector)));}
    break;

  case 308:
/* Line 670 of lalr1.cc  */
#line 1454 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  if (aNum < MAXANNULI)
	    aAnnuli[aNum++] = (yysemantic_stack_[(1) - (1)].real);
	}
    break;

  case 311:
/* Line 670 of lalr1.cc  */
#line 1465 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  if (aAngNum < MAXANGLES)
	    aAngles[aAngNum++] = (yysemantic_stack_[(1) - (1)].real);
	}
    break;

  case 314:
/* Line 670 of lalr1.cc  */
#line 1475 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {aVector[aNum++] = Vector((yysemantic_stack_[(3) - (1)].real),(yysemantic_stack_[(3) - (3)].real));}
    break;

  case 315:
/* Line 670 of lalr1.cc  */
#line 1479 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"
    {
	  // old style annulus
	  switch (aStatus) {
	  case 0: // do nothing
	    break;
	  case 1: // we found just an ellipse, do nothing
	    break;
	  case 2: // ok we have an ellipse annulus
	    fr->markerDeleteLastCmd(); // delete the previous ellipse
	    fr->createEllipseAnnulusCmd(aCenter,
	      aNumsao,aVector,
	      aAngles[0],
	      aColor,aDash,aWidth,aFont,aText,aProps,aComment,taglist/*,cblist*/);
	    break;
	  case 3: // we found just a box, do nothing
	    break;
	  case 4: // ok, we have a box annulus
	    fr->markerDeleteLastCmd(); // delete the previous box
	    fr->createBoxAnnulusCmd(aCenter,
	      aNumsao,aVector,
	      aAngles[0],
	      aColor,aDash,aWidth,aFont,aText,aProps,aComment,taglist/*,cblist*/);
	    break;
	  }
	  aStatus = 0;
	}
    break;


/* Line 670 of lalr1.cc  */
#line 2833 "ds9parse.cpp"
      default:
        break;
      }

    /* User semantic actions sometimes alter yychar, and that requires
       that yytoken be updated with the new translation.  We take the
       approach of translating immediately before every use of yytoken.
       One alternative is translating here after every semantic action,
       but that translation would be missed if the semantic action
       invokes YYABORT, YYACCEPT, or YYERROR immediately after altering
       yychar.  In the case of YYABORT or YYACCEPT, an incorrect
       destructor might then be invoked immediately.  In the case of
       YYERROR, subsequent parser actions might lead to an incorrect
       destructor call or verbose syntax error message before the
       lookahead is translated.  */
    YY_SYMBOL_PRINT ("-> $$ =", yyr1_[yyn], &yyval, &yyloc);

    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();

    yysemantic_stack_.push (yyval);
    yylocation_stack_.push (yyloc);

    /* Shift the result of the reduction.  */
    yyn = yyr1_[yyn];
    yystate = yypgoto_[yyn - yyntokens_] + yystate_stack_[0];
    if (0 <= yystate && yystate <= yylast_
	&& yycheck_[yystate] == yystate_stack_[0])
      yystate = yytable_[yystate];
    else
      yystate = yydefgoto_[yyn - yyntokens_];
    goto yynewstate;

  /*------------------------------------.
  | yyerrlab -- here on detecting error |
  `------------------------------------*/
  yyerrlab:
    /* Make sure we have latest lookahead translation.  See comments at
       user semantic actions for why this is necessary.  */
    yytoken = yytranslate_ (yychar);

    /* If not already recovering from an error, report this error.  */
    if (!yyerrstatus_)
      {
	++yynerrs_;
	if (yychar == yyempty_)
	  yytoken = yyempty_;
	error (yylloc, yysyntax_error_ (yystate, yytoken));
      }

    yyerror_range[1] = yylloc;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */
        if (yychar <= yyeof_)
          {
            /* Return failure if at end of input.  */
            if (yychar == yyeof_)
              YYABORT;
          }
        else
          {
            yydestruct_ ("Error: discarding", yytoken, &yylval, &yylloc);
            yychar = yyempty_;
          }
      }

    /* Else will try to reuse lookahead token after shifting the error
       token.  */
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:

    /* Pacify compilers like GCC when the user code never invokes
       YYERROR and the label yyerrorlab therefore never appears in user
       code.  */
    if (false)
      goto yyerrorlab;

    yyerror_range[1] = yylocation_stack_[yylen - 1];
    /* Do not reclaim the symbols of the rule which action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    yystate = yystate_stack_[0];
    goto yyerrlab1;

  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;	/* Each real token shifted decrements this.  */

    for (;;)
      {
	yyn = yypact_[yystate];
	if (!yy_pact_value_is_default_ (yyn))
	{
	  yyn += yyterror_;
	  if (0 <= yyn && yyn <= yylast_ && yycheck_[yyn] == yyterror_)
	    {
	      yyn = yytable_[yyn];
	      if (0 < yyn)
		break;
	    }
	}

	/* Pop the current state because it cannot handle the error token.  */
	if (yystate_stack_.height () == 1)
	  YYABORT;

	yyerror_range[1] = yylocation_stack_[0];
	yydestruct_ ("Error: popping",
		     yystos_[yystate],
		     &yysemantic_stack_[0], &yylocation_stack_[0]);
	yypop_ ();
	yystate = yystate_stack_[0];
	YY_STACK_PRINT ();
      }

    yyerror_range[2] = yylloc;
    // Using YYLLOC is tempting, but would change the location of
    // the lookahead.  YYLOC is available though.
    YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
    yysemantic_stack_.push (yylval);
    yylocation_stack_.push (yyloc);

    /* Shift the error token.  */
    YY_SYMBOL_PRINT ("Shifting", yystos_[yyn],
		     &yysemantic_stack_[0], &yylocation_stack_[0]);

    yystate = yyn;
    goto yynewstate;

    /* Accept.  */
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;

    /* Abort.  */
  yyabortlab:
    yyresult = 1;
    goto yyreturn;

  yyreturn:
    if (yychar != yyempty_)
      {
        /* Make sure we have latest lookahead translation.  See comments
           at user semantic actions for why this is necessary.  */
        yytoken = yytranslate_ (yychar);
        yydestruct_ ("Cleanup: discarding lookahead", yytoken, &yylval,
                     &yylloc);
      }

    /* Do not reclaim the symbols of the rule which action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    while (1 < yystate_stack_.height ())
      {
        yydestruct_ ("Cleanup: popping",
                     yystos_[yystate_stack_[0]],
                     &yysemantic_stack_[0],
                     &yylocation_stack_[0]);
        yypop_ ();
      }

    return yyresult;
    }
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack"
                 << std::endl;
        // Do not try to display the values of the reclaimed symbols,
        // as their printer might throw an exception.
        if (yychar != yyempty_)
          {
            /* Make sure we have latest lookahead translation.  See
               comments at user semantic actions for why this is
               necessary.  */
            yytoken = yytranslate_ (yychar);
            yydestruct_ (YY_NULL, yytoken, &yylval, &yylloc);
          }

        while (1 < yystate_stack_.height ())
          {
            yydestruct_ (YY_NULL,
                         yystos_[yystate_stack_[0]],
                         &yysemantic_stack_[0],
                         &yylocation_stack_[0]);
            yypop_ ();
          }
        throw;
      }
  }

  // Generate an error message.
  std::string
  ds9parse::yysyntax_error_ (int yystate, int yytoken)
  {
    std::string yyres;
    // Number of reported tokens (one for the "unexpected", one per
    // "expected").
    size_t yycount = 0;
    // Its maximum.
    enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
    // Arguments of yyformat.
    char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];

    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yytoken) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yychar.
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state
         merging (from LALR or IELR) and default reductions corrupt the
         expected token list.  However, the list is correct for
         canonical LR with one exception: it will still contain any
         token that will not be accepted due to an error action in a
         later state.
    */
    if (yytoken != yyempty_)
      {
        yyarg[yycount++] = yytname_[yytoken];
        int yyn = yypact_[yystate];
        if (!yy_pact_value_is_default_ (yyn))
          {
            /* Start YYX at -YYN if negative to avoid negative indexes in
               YYCHECK.  In other words, skip the first -YYN actions for
               this state because they are default actions.  */
            int yyxbegin = yyn < 0 ? -yyn : 0;
            /* Stay within bounds of both yycheck and yytname.  */
            int yychecklim = yylast_ - yyn + 1;
            int yyxend = yychecklim < yyntokens_ ? yychecklim : yyntokens_;
            for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
              if (yycheck_[yyx + yyn] == yyx && yyx != yyterror_
                  && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
                {
                  if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                    {
                      yycount = 1;
                      break;
                    }
                  else
                    yyarg[yycount++] = yytname_[yyx];
                }
          }
      }

    char const* yyformat = YY_NULL;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
        YYCASE_(0, YY_("syntax error"));
        YYCASE_(1, YY_("syntax error, unexpected %s"));
        YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    // Argument number.
    size_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += yytnamerr_ (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
  const short int ds9parse::yypact_ninf_ = -667;
  const short int
  ds9parse::yypact_[] =
  {
      -667,    50,  1380,  -667,  -667,  -667,    32,  -667,  -667,  -667,
    -667,  -667,  -667,  2238,  -667,  -667,  -667,  -667,  -667,  -667,
    -667,    62,  -667,  -667,  -667,  -667,  -667,  -667,  -667,  -667,
    -667,  -667,  -667,  -667,  -667,  -667,  -667,  -667,  -667,  -667,
    -667,  -667,  -667,  -667,  -667,  -667,  -667,  -667,  -667,  -667,
    -667,  1204,   131,  -667,  -667,  -667,  1096,  -667,  -667,  -667,
    -667,   -57,   -52,   -25,    14,    34,  -667,  -667,  -667,    38,
    -667,  -667,    42,  -667,    49,  -667,    71,  -667,    75,    86,
      88,    89,    91,   104,   107,   115,    60,  -667,    -6,  -667,
     131,  -667,  -667,  -667,  -667,    -6,    -6,     5,     5,     5,
       5,     5,     5,     5,     5,     5,     5,     5,     5,     5,
       5,  -667,     5,     5,     5,  -667,     5,     5,   -18,  -667,
    -667,  2031,  -667,   138,  1812,   217,   227,   246,   249,   261,
    1488,   257,   315,   260,   262,  2267,   263,    36,  -667,  -667,
    -667,  2238,  -667,  -667,  -667,  -667,  -667,   448,   448,   448,
     448,   448,   448,   448,   448,   448,   448,   137,   448,   448,
     448,     5,   448,   448,   448,     5,   448,   448,     5,     5,
       5,     5,     5,     5,   269,     5,  -667,   259,   308,  -667,
    -667,  -667,  -667,   273,  -667,   272,  -667,   271,  -667,   278,
    -667,  -667,  -667,  -667,  -667,  -667,  -667,   279,  -667,  -667,
    -667,  2028,  -667,  1704,  2028,  -667,  -667,  -667,  -667,  -667,
    -667,  -667,  -667,  -667,  -667,  -667,  -667,  -667,  -667,  -667,
    -667,  -667,  -667,  -667,  -667,  -667,  -667,  -667,   281,  -667,
     158,   158,   158,  -667,  -667,  -667,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
    -667,   156,   158,   158,   137,   448,   158,   158,   158,   448,
      -4,   158,   448,   448,   448,   448,   448,   448,  -667,   448,
    -667,  -667,  -667,   287,  -667,  -667,  -667,  -667,  -667,  -667,
    2136,  -667,  -667,  -667,  -667,   286,   288,   301,   176,   303,
     305,   305,   543,   558,   315,   543,   543,   543,   315,   315,
     558,   315,   187,   194,   448,   315,   156,  -667,    85,  -667,
     448,   558,   448,    85,   325,   156,   543,   158,   158,   158,
     158,   158,   137,   158,   329,   -10,  -667,  -667,  -667,  -667,
    -667,  -667,  -667,  -667,  -667,  -667,  -667,  -667,  -667,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   137,   137,
     137,   137,  -667,   158,   158,   158,  -667,  2138,  -667,  -667,
     137,   158,   194,   448,   156,   158,   158,   137,   156,   137,
     194,   158,   543,   543,   315,   448,   448,   156,   543,   335,
    -667,   543,   333,   334,   336,   337,   338,   176,   433,   315,
     156,   156,   156,   156,   315,   433,   315,  -667,   210,   212,
     218,   234,   235,   236,    14,   241,   242,   243,   244,   245,
     247,    75,   248,   254,   256,   258,   267,   282,   357,   283,
      37,  -667,   156,   315,  -667,  -667,   194,   543,   315,   156,
     194,  -667,  -667,   315,   137,   137,   137,   158,   137,  1325,
     158,  -667,    85,  -667,  -667,  -667,  -667,  -667,  -667,     0,
       2,   137,   158,   158,   194,   194,   194,   194,   158,   137,
     158,   158,   320,   864,   389,  1920,   381,   352,   394,   353,
     393,   420,   261,  1596,   419,   421,   315,   427,   431,   435,
    -667,    36,   434,  2138,  -667,   194,    85,  -667,   137,   137,
     194,  -667,   156,   137,   156,   156,   156,   543,   156,  -667,
     442,    51,  -667,   315,   291,   156,  -126,    40,   447,  -667,
    -667,  -667,  -667,   453,   -97,   237,   454,  -667,  -667,   293,
       6,  -667,  -667,  -667,    52,  -667,  -667,  -667,  -667,  -667,
    -667,  -667,  -667,  -667,  -667,  -667,  -667,   462,  -667,  -667,
     273,  -667,   469,  -667,  -667,  -667,   326,   463,  -667,  -667,
     343,  -667,   474,   477,  2028,  -667,  1704,  2028,  -667,  -667,
    -667,  -667,  -667,  -667,  -667,  -667,  -667,  -667,  -667,  -667,
    -667,    40,   156,   156,   156,  -667,   194,   156,  1325,  1325,
    1325,   137,  1325,  -667,   476,  -667,   137,   347,  -667,   137,
      85,  -667,   194,   348,   194,   137,   158,   158,   158,   349,
     194,    55,    95,   137,   158,   158,   158,  -667,   158,   315,
    -667,  -667,  -667,  -667,  -667,  -667,   481,  -667,   485,   315,
    -667,   315,  -667,  -667,  -667,  -667,  -667,  2136,  -667,  -667,
    -667,  -667,  -667,   137,    85,  -667,   194,   194,   194,  -667,
     194,  -667,  -667,  -667,   156,  -667,  -667,  -667,   156,   490,
     156,   543,   156,  -667,   468,  -667,   156,   315,   558,   543,
     449,  -667,   156,   543,   315,   461,   558,   -93,  -667,   493,
     -70,   -33,   -10,   156,   315,   156,  -667,  -667,  -667,  -667,
    1325,  -667,  1325,  -667,   194,  -667,   194,     5,   194,   137,
     158,   158,     5,   194,  -667,   137,   137,  -667,   158,   365,
     499,   376,   377,  -667,   194,  -667,   194,  -667,  -667,  -667,
    -667,   448,  -667,   156,   558,   543,   448,  -667,   156,   156,
     558,   543,  -667,   543,   543,  -667,  -667,   158,   194,   158,
     158,   158,   194,   194,   158,   -16,     8,     9,   558,  -667,
     510,   511,   558,  -667,  -667,   513,   383,   543,  -667,   385,
     158,   158,   137,   158,   158,   315,   315,   315,   315,   156,
     315,   315,   390,   391,   137,   137,   194,   137,   137,  -667,
    -667,  -667,   156,  -667,  -667,   156,   194,   194,  -667,  -667
  };

  /* YYDEFACT[S] -- default reduction number in state S.  Performed when
     YYTABLE doesn't specify something else to do.  Zero means the
     default is an error.  */
  const unsigned short int
  ds9parse::yydefact_[] =
  {
       202,     0,   250,     1,    94,   125,     0,    93,   132,   124,
     126,   127,   130,     0,   133,   129,    91,   128,    14,    92,
     131,     0,     7,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   250,     0,    10,    95,    12,     0,    44,    43,     6,
     178,     0,     0,     0,   176,     0,   144,   141,   140,     0,
     138,   145,     0,   142,     0,   143,     0,   137,   177,     0,
       0,     0,     0,     0,     0,     0,    54,   169,    24,     9,
       0,     2,    40,    39,     4,    24,    24,    56,    56,    56,
      56,    56,    56,    56,    56,    56,    56,    56,    56,    56,
      56,   272,    56,    56,    56,   274,    56,    56,    22,   258,
     259,     0,    16,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    25,    55,
       8,     0,    15,     3,    11,    13,    57,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    58,     0,     0,
       0,    56,     0,     0,     0,    56,     0,     0,    56,    56,
      56,    56,    56,    56,     0,    56,    18,     0,     0,    19,
      17,   171,   201,   199,   200,     0,   183,     0,   174,     0,
     256,   252,   257,   251,   254,   253,   255,   179,   135,   136,
     134,     0,   197,     0,     0,   196,   184,   175,    42,    41,
      66,    67,    65,   186,   187,   182,   188,   173,    45,    53,
      51,    50,    52,    48,    49,    47,    46,   170,     0,   168,
      54,    54,    54,    81,    82,    83,    54,    54,    54,    54,
      54,    54,    54,    54,    54,    54,    54,    54,    54,    54,
      59,    60,    54,    54,    58,     0,    54,    54,    54,     0,
      58,    54,     0,     0,     0,     0,     0,     0,    21,     0,
      23,    20,   198,     0,   172,   181,   180,   194,   195,   190,
       0,   191,   192,   193,    26,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    63,     0,
       0,     0,    61,   315,     0,     0,    60,   305,    54,   304,
       0,     0,     0,    54,     0,    60,     0,    54,    54,    54,
      54,    54,    58,    54,     0,     0,    88,    90,    89,    87,
      84,    85,    86,    71,    72,    73,    69,    70,    68,    54,
      54,    54,    54,    54,    54,    54,    54,    54,    58,    58,
      58,    58,    64,    54,    54,    54,    62,    28,   301,    27,
      58,    54,   315,     0,    60,    54,    54,    58,    60,    58,
     315,    54,     0,     0,    63,     0,     0,    60,     0,     0,
     189,     0,     0,     0,     0,     0,     0,     0,    63,     0,
      60,    60,    60,    60,     0,    63,     0,   215,     0,     0,
       0,     0,     0,     0,   213,     0,     0,     0,     0,     0,
       0,   214,     0,     0,     0,     0,     0,     0,     0,     0,
      54,   204,    60,     0,   281,   303,   315,     0,    63,    60,
     315,   279,   278,     0,    58,    58,    58,    54,    58,   315,
      54,   185,    54,    77,    78,    79,    75,    76,    74,    66,
      65,    58,    54,    54,   315,   315,   315,   315,    54,    58,
      54,    54,   247,     0,     0,     0,     0,   241,     0,   244,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     315,     0,     0,     0,    30,   315,    54,   273,    58,    58,
     315,   275,    60,    58,    60,    60,    60,     0,    60,   260,
       0,    54,    33,     0,     0,    60,    60,    63,     0,   267,
     268,   283,   302,     0,    60,    63,     0,   249,   227,     0,
       0,   162,   160,   155,     0,   165,   149,   166,   152,   164,
     158,   147,   161,   150,   148,   167,   163,     0,   206,   240,
     238,   239,     0,   220,   243,   225,     0,     0,   246,   226,
       0,   209,     0,   216,     0,   236,     0,     0,   235,   221,
     211,   210,   223,   224,   219,   208,    29,   205,   315,   203,
     276,     0,    60,    60,    60,   282,   315,    60,   315,   315,
     315,    58,   315,   315,     0,    36,    58,     0,   308,    58,
      54,   307,   315,     0,   315,    58,    54,    54,    54,     0,
     315,    71,    68,    58,    54,    54,    54,   313,    54,     0,
     154,   151,   157,   156,   153,   159,     0,   237,     0,     0,
     207,     0,   218,   217,   233,   234,   229,     0,   230,   231,
     232,    32,   311,    58,    54,   310,   315,   315,   315,   280,
     315,   266,   265,   261,    60,   264,    35,   315,    60,     0,
      60,     0,    60,   285,     0,   270,    60,    63,     0,     0,
       0,   269,    60,     0,    63,    63,     0,    54,   212,     0,
      54,    54,     0,    60,     0,    60,   298,   284,   271,   277,
     315,    38,   315,    80,   315,   306,   315,    56,   315,    58,
      54,    54,    56,   315,   314,    58,    58,   312,    54,     0,
       0,     0,     0,   228,   315,   309,   315,   263,   262,   287,
     286,     0,   292,    60,     0,     0,     0,   288,    60,    60,
       0,     0,   222,     0,     0,   300,   299,    54,   315,    54,
      54,    54,   315,   315,    54,    54,    54,    54,     0,   293,
       0,     0,     0,   289,   290,     0,     0,     0,   242,     0,
      54,    54,    58,    54,    54,     0,     0,    63,    63,    60,
      63,    63,     0,     0,    58,    58,   315,    58,    58,   248,
     245,   294,    60,   295,   291,    60,   315,   315,   297,   296
  };

  /* YYPGOTO[NTERM-NUM].  */
  const short int
  ds9parse::yypgoto_[] =
  {
      -667,  -667,  -667,   475,  -667,  -667,  -667,  -667,  -667,    26,
    -667,   512,  -667,  -667,  -444,  -667,  -667,   437,   111,  -667,
      44,   -86,   -81,   312,   422,  -329,  -118,   379,   -27,  -458,
     239,  -667,   -77,    45,   -78,   395,  -121,  -108,   -11,  -667,
    -667,   388,  -667,  -667,  -667,   180,    57,  -667,  -667,  -667,
    -667,  -667,  -667,  -667,  -667,  -667,    69,   424,   367,   430,
    -667,  -667,  -667,   284,   185,  -166,   -92,  -540,  -116,  -666,
    -631,   -47
  };

  /* YYDEFGOTO[NTERM-NUM].  */
  const short int
  ds9parse::yydefgoto_[] =
  {
        -1,     1,    51,    52,    95,    96,    88,   176,   177,   140,
     228,   358,   418,   482,   499,   500,   584,    94,   236,    59,
     227,   674,   147,   251,   303,   351,   352,   604,   346,   589,
     237,   238,   239,   307,    53,    54,    55,   205,   419,   537,
      86,    87,   206,   185,     2,   501,   421,   559,   542,   545,
     546,   549,   550,   518,   519,    56,   197,   121,   179,   122,
     161,   165,   492,   308,   309,   590,   591,   634,   635,   606,
     607,   359
  };

  /* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule which
     number is the opposite.  If YYTABLE_NINF_, syntax error.  */
  const short int ds9parse::yytable_ninf_ = -316;
  const short int
  ds9parse::yytable_[] =
  {
       141,   -54,    85,   184,    91,   -54,   -54,   -54,   302,   204,
     198,   199,   593,   168,   213,   169,   170,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     200,   162,   163,   164,   697,   166,   167,   302,   139,   218,
     699,   599,   -31,   208,   209,   436,   183,   210,   211,   596,
       3,   610,   203,  -315,  -315,   735,   -37,   605,   737,   451,
     171,   139,   272,   701,   172,    89,   459,  -315,  -315,   667,
     173,   -66,   -66,   174,   611,   175,   -24,   -24,   123,   670,
     255,   671,   280,   124,   259,   219,   612,   262,   263,   264,
     265,   266,   267,   278,   269,   281,   283,   613,   139,   489,
     702,   -58,   -58,    57,    58,   220,   221,   222,   223,   587,
     125,   -65,   -65,   633,   142,   139,   697,   746,   119,   120,
     614,   144,   145,   277,   138,   279,   282,   139,   224,   250,
      85,   139,   615,   139,   641,   642,   643,   146,   645,   139,
     139,   748,   749,   181,   285,   286,   287,    92,    93,  -139,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   225,   226,   304,   305,   139,   126,
     310,   311,   312,   127,   314,   316,   347,   128,   595,   208,
     209,   353,   139,   355,   129,   -66,   603,   361,   -66,   -66,
     138,   139,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   325,   252,   253,   254,   130,   256,   257,   258,
    -146,   260,   261,   331,   332,   -58,   139,   380,   250,   -58,
     186,   131,   363,   132,   133,   -65,   134,   363,   -65,   -65,
     187,   372,   373,   374,   375,   376,   707,   378,   708,   135,
     208,   209,   136,   212,   601,   211,   334,   335,   336,   337,
     137,   188,   189,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   207,   214,   270,   215,   217,   394,   395,   396,
     250,   453,   268,   354,   274,   423,   458,   273,   461,   427,
     428,   275,   276,   190,   366,   433,   284,   191,   192,   139,
     302,   193,   324,   326,   208,   209,     5,   194,   333,   327,
     334,   335,   336,   337,   195,   486,   587,   317,   318,   319,
     320,   321,   322,   328,   323,   493,   233,     8,   208,   209,
     235,   356,   210,   211,   357,     9,    10,    11,   689,    12,
     369,    14,   379,    15,   483,   695,   696,    17,   441,   168,
     443,   169,   170,   444,   541,   462,   445,   463,   446,   360,
     447,   497,   557,   464,   503,   365,   504,   367,   562,    20,
     587,   452,   480,   382,   387,   558,   507,   508,   460,   465,
     466,   467,   513,   484,   515,   516,   468,   469,   470,   471,
     472,   517,   473,   474,   543,   586,   171,   540,   196,   475,
     172,   476,   502,   477,   538,   556,   173,   547,   551,   329,
     571,   175,   478,   338,   345,   212,   338,   338,   338,   212,
     212,   345,   212,   544,   548,   483,   212,   479,   481,   617,
     437,   438,   345,   552,   560,   609,   561,   338,   764,   765,
     563,   767,   768,   566,   564,   627,   208,   209,   565,   568,
     449,   211,   341,   342,   343,   344,   625,   583,   628,   630,
     597,   208,   209,   632,   585,   230,   598,   608,   619,   231,
     232,   233,   234,   235,   208,   209,   620,   616,   601,   211,
     334,   335,   336,   337,   618,   621,   624,   622,   626,   629,
     623,   647,   649,   338,   338,   212,   668,   654,   660,   338,
     669,   632,   338,   683,   687,   692,   700,   721,   448,   450,
     212,   632,   722,   632,   651,   212,   450,   212,   723,   724,
     657,   658,   659,   751,   752,   755,   754,   756,   663,   664,
     665,   631,   666,   769,   770,   567,    90,   143,   330,   229,
     216,   502,   502,   502,   212,   502,   646,   420,   338,   212,
     569,   553,   178,   313,   212,   271,   208,   209,   425,   672,
     333,   180,   334,   335,   336,   337,   632,   736,   705,   685,
       0,   208,   209,     0,   703,   340,   306,   341,   342,   343,
     344,     0,   315,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   212,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     681,     0,     0,     0,   714,   715,   711,     0,   338,     0,
       0,   716,   720,     0,   212,   338,     0,     0,   212,     0,
     364,     0,     0,     0,     0,   368,   602,     0,     0,     0,
       0,   690,     0,   502,   377,   502,     0,   762,   763,   698,
       0,   738,     0,   740,   741,   742,     0,     0,   745,   747,
     651,   747,     0,     0,     0,     0,     0,     0,     0,     0,
     390,   391,   392,   393,   757,   758,     0,   760,   761,     0,
       0,   339,   422,     0,   348,   349,   350,     0,     0,   429,
       0,   431,   212,     0,     0,     0,     0,   729,     0,     0,
       0,     0,     0,   734,     0,   371,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   750,     0,     0,     0,   753,     0,     0,     0,     0,
     212,     0,     0,     0,     0,     0,     0,     0,   362,     0,
     212,     0,   212,     0,     0,     0,     0,   370,     0,     0,
       0,     0,     0,     0,     0,     0,   494,   495,   496,     0,
     498,   434,   435,     0,   505,     0,   727,   440,     0,     0,
     442,   731,   338,   506,     0,     0,     0,     0,   212,   345,
     338,   514,     0,     0,   338,   212,   602,   345,     0,     0,
       0,     0,     0,     0,     0,   212,   426,     0,     0,     0,
     430,     0,     0,     0,     0,     0,     0,     0,   572,   439,
     573,   574,     0,     0,     0,   577,   488,     0,     0,     0,
       0,     0,   454,   455,   456,   457,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   345,   338,     0,     0,     0,
       0,   345,   338,     0,   338,   338,     0,     0,     0,     0,
       0,     0,     0,     0,   485,     0,     0,     0,     0,   345,
       0,   490,     0,   345,     0,     0,     0,     0,   338,     0,
       0,     0,     0,     0,     0,     0,   212,   212,   212,   212,
       0,   212,   212,     0,   424,     0,   581,     0,     0,     0,
       0,     0,   432,   588,     0,     0,     0,     0,     0,   520,
       0,     0,     0,   644,     0,     0,   521,     0,   648,     0,
       0,   650,   652,     0,     0,   522,     0,   656,     0,   523,
       0,   524,     0,     0,   576,   662,   578,   579,   580,   525,
     582,     0,     0,   526,     0,     0,     0,   592,   594,   527,
       0,     0,   528,     0,     0,     0,   600,     0,   487,     0,
       0,     0,   491,   529,   530,   673,   675,     0,   531,     0,
       0,     0,   532,     0,     0,     0,     0,     0,     0,   533,
     534,   535,     0,     0,     0,     0,   509,   510,   511,   512,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     536,     0,     0,     0,   636,   637,   638,   570,     0,   640,
       0,   713,   575,     0,     0,     0,     0,   718,   719,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     588,     0,     0,     0,     0,     0,     0,     0,   691,     0,
       0,     0,   694,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   759,     0,   680,     0,     0,     0,
     682,     0,   684,     0,   686,     0,   771,   772,   688,   774,
     775,     0,     0,     0,   693,     0,     0,     0,   639,     0,
       0,     0,     0,     0,   730,   704,     0,   706,     0,     0,
       0,     0,   588,     0,   653,     0,   655,     0,     0,     0,
       0,     0,   661,     0,     0,    97,     0,     0,     0,     0,
       0,     0,    98,     0,    99,     0,   100,   101,     0,   102,
     103,   104,     0,     0,     0,   728,     0,     0,     0,     0,
     732,   733,   105,     0,   106,     0,   107,     0,   676,   677,
     678,     0,   679,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   108,     0,     0,     0,     0,     0,     0,     0,
     109,     0,   110,   111,   112,     0,     0,   113,   114,   115,
       0,   766,     0,     0,   116,     0,     0,     0,     0,   117,
       0,     0,     0,     0,   776,     0,   709,   777,   710,     0,
     712,     0,     0,     0,  -315,   717,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   725,     0,   726,     0,
      -5,    -5,     4,     0,     0,     0,   118,     5,     0,     0,
       0,     0,   119,   120,     0,     0,     0,     0,     0,     0,
     739,     0,     0,     6,   743,   744,     7,     0,     8,     0,
       0,     0,     0,     0,     0,     0,     9,    10,    11,     0,
      12,    13,    14,     0,    15,     0,    16,     0,    17,     0,
       0,    18,     0,     0,     0,     0,     0,    19,   773,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   778,   779,
      20,     0,     0,     0,     0,    21,     0,     0,    22,     0,
       0,     0,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
     -34,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   397,
       0,     0,     0,   398,   399,     0,     0,   400,   401,   402,
     403,     0,   404,   405,     0,     0,    66,     0,     0,     0,
      67,     0,     0,   406,     0,     0,    68,     0,     0,     0,
     407,     0,     0,     0,    70,     0,     0,     0,    71,     0,
       0,   408,     0,    73,     0,     0,    -5,    -5,     4,     0,
       0,   409,     0,     5,     0,    75,     0,   410,     0,    77,
     411,     0,   412,   413,   414,   415,     0,     0,   416,     6,
       0,     0,     7,     0,     8,     0,     0,     0,     0,     0,
       0,     0,     9,    10,    11,     0,    12,    13,    14,     0,
      15,     0,    16,     0,    17,     0,     0,    18,     0,     0,
       0,   417,     0,    19,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    20,     0,     0,     0,
       0,    21,     0,     0,    22,     0,     0,     0,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,     4,     0,   198,   199,
       0,     5,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   200,     0,
       7,     0,     8,     0,     0,     0,     0,     0,     0,     0,
       9,    10,    11,     0,    12,     0,    14,     0,    15,     0,
      16,     0,    17,     0,     0,   201,     0,     0,     0,     0,
       0,    19,     0,   202,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    20,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,     4,     0,   198,   199,     0,     5,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   200,     0,     7,     0,
       8,     0,     0,     0,     0,     0,     0,     0,     9,    10,
      11,     0,    12,     0,    14,     0,    15,     0,    16,     0,
      17,     0,     0,   554,     0,     0,     0,     0,     0,    19,
       0,   555,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    20,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,     4,     0,   198,   199,     0,     5,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   200,     0,     7,     0,     8,     0,
       0,     0,     0,     0,     0,     0,     9,    10,    11,     0,
      12,     0,    14,     0,    15,     0,    16,     0,    17,     0,
       0,     0,     0,     0,     0,     0,     0,    19,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      20,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
       4,     0,     0,     0,     0,     5,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     7,     0,     8,     0,     0,     0,
       0,     0,     0,     0,     9,    10,    11,     0,    12,     0,
      14,     0,    15,     0,    16,     0,    17,     0,     0,   182,
       0,     0,     0,     0,     0,    19,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    20,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,     4,     0,
       0,     0,     0,     5,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     7,     0,     8,     0,     0,     0,     0,     0,
       0,     0,     9,    10,    11,     0,    12,     0,    14,     0,
      15,     0,    16,     0,    17,     0,     0,   539,     0,     0,
       0,     0,     0,    19,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    20,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,     4,     0,   198,   199,
      97,     0,     0,     0,     0,     0,     0,    98,     0,    99,
       0,   100,   101,     0,   102,   103,   104,     0,   200,     0,
       7,     0,     0,     0,     0,     0,     0,   105,     0,   106,
       0,   107,     0,     0,     0,     0,     0,     0,     0,     0,
      16,     0,     0,     0,     0,     0,     0,   108,     0,     0,
       0,    19,     0,     0,     0,   109,     0,   110,   111,   112,
       0,     0,   113,   114,   115,     0,     0,     0,     0,   116,
       0,     0,     0,     0,   117,     0,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,     4,     0,     0,     0,     0,     0,
       0,     0,   397,     0,     0,     0,   398,   399,     0,     0,
     400,   401,   402,   403,     0,   404,   405,     0,     7,    66,
       0,     0,     0,    67,     0,     0,   406,     0,     0,    68,
       0,     0,     0,   407,     0,     0,     0,    70,    16,     0,
       0,    71,     0,     0,   408,     0,    73,     0,     0,    19,
       0,     0,     0,     0,   409,     0,     0,     0,    75,     0,
     410,     0,    77,   411,     0,   412,   413,   414,   415,     0,
       0,   416,     0,     0,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    60,     0,   417,     0,     0,     0,     0,     0,
      61,    62,    63,     0,     0,    64,    65,     0,     0,    66,
       0,     0,     0,    67,     0,     0,     0,     0,     0,    68,
       0,     0,     0,    69,     0,     0,     0,    70,     0,     0,
       0,    71,     0,     0,    72,     0,    73,     0,     0,     0,
       0,     0,     0,     0,    74,     0,     0,     0,    75,     0,
      76,     0,    77,    78,     0,     0,    79,    80,    81,     0,
       0,    82,     0,     0,     0,     0,    83,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    84,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50
  };

  /* YYCHECK.  */
  const short int
  ds9parse::yycheck_[] =
  {
        86,     5,    13,   124,    51,     3,     4,     7,   134,   130,
      20,    21,   138,    31,   132,    33,    34,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
      40,   112,   113,   114,   665,   116,   117,   134,   131,     3,
     133,   138,     5,     3,     4,   374,   124,     7,     8,   507,
       0,    45,   130,    16,    17,   721,     5,   515,   724,   388,
      78,   131,   183,   133,    82,     3,   395,    16,    17,   609,
      88,    16,    17,    91,    68,    93,    16,    17,   135,   619,
     161,   621,   203,   135,   165,    49,    80,   168,   169,   170,
     171,   172,   173,   201,   175,   203,   204,    45,   131,   428,
     133,    16,    17,    71,    72,    69,    70,    71,    72,    69,
     135,    16,    17,   571,    88,   131,   747,   133,   136,   137,
      68,    95,    96,   201,   130,   203,   204,   131,    92,   133,
     141,   131,    80,   131,   578,   579,   580,   132,   582,   131,
     131,   133,   133,     5,   230,   231,   232,    16,    17,   135,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   128,   129,   252,   253,   131,   135,
     256,   257,   258,   135,   260,   261,   294,   135,   507,     3,
       4,   299,   131,   301,   135,   130,   515,   305,   133,   134,
     130,   131,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   280,   158,   159,   160,   135,   162,   163,   164,
     135,   166,   167,   290,   291,   130,   131,   325,   133,   134,
       3,   135,   308,   135,   135,   130,   135,   313,   133,   134,
       3,   317,   318,   319,   320,   321,   680,   323,   682,   135,
       3,     4,   135,   132,     7,     8,     9,    10,    11,    12,
     135,     5,     3,   339,   340,   341,   342,   343,   344,   345,
     346,   347,     5,     3,     5,     3,     3,   353,   354,   355,
     133,   389,     3,   300,     3,   361,   394,     5,   396,   365,
     366,     3,     3,    22,   311,   371,     5,    26,    27,   131,
     134,    30,     5,     7,     3,     4,    23,    36,     7,    11,
       9,    10,    11,    12,    43,   423,    69,   262,   263,   264,
     265,   266,   267,    12,   269,   433,    13,    44,     3,     4,
      15,   134,     7,     8,   130,    52,    53,    54,   657,    56,
       5,    58,     3,    60,   420,   664,   665,    64,     3,    31,
       7,    33,    34,     9,   465,   135,    10,   135,    11,   304,
      12,   437,   473,   135,   440,   310,   442,   312,   476,    86,
      69,   388,     5,   449,   450,   473,   452,   453,   395,   135,
     135,   135,   458,   420,   460,   461,   135,   135,   135,   135,
     135,    61,   135,   135,     3,   503,    78,   465,   127,   135,
      82,   135,   439,   135,     5,   473,    88,     3,     5,   288,
     486,    93,   135,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    61,    61,   501,   305,   135,   135,   540,
     375,   376,   311,     3,     5,   132,     5,   316,   757,   758,
       3,   760,   761,   480,     3,   556,     3,     4,     3,     5,
       7,     8,     9,    10,    11,    12,   554,     5,   556,   557,
       3,     3,     4,   571,   501,     7,     3,     3,   132,    11,
      12,    13,    14,    15,     3,     4,     3,     5,     7,     8,
       9,    10,    11,    12,     5,   132,   554,     3,   556,   557,
       3,     5,   135,   372,   373,   374,     5,   139,   139,   378,
       5,   609,   381,     3,    26,    46,     3,   132,   387,   388,
     389,   619,     3,   621,   590,   394,   395,   396,   132,   132,
     596,   597,   598,     3,     3,   132,     3,   132,   604,   605,
     606,   568,   608,   133,   133,   481,    51,    90,   289,   141,
     135,   578,   579,   580,   423,   582,   583,   357,   427,   428,
     483,   472,   118,   259,   433,   178,     3,     4,   363,   627,
       7,   121,     9,    10,    11,    12,   674,   723,   674,   651,
      -1,     3,     4,    -1,   672,     7,   254,     9,    10,    11,
      12,    -1,   260,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   476,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     647,    -1,    -1,    -1,   690,   691,   687,    -1,   497,    -1,
      -1,   692,   698,    -1,   503,   504,    -1,    -1,   507,    -1,
     308,    -1,    -1,    -1,    -1,   313,   515,    -1,    -1,    -1,
      -1,   658,    -1,   680,   322,   682,    -1,   755,   756,   666,
      -1,   727,    -1,   729,   730,   731,    -1,    -1,   734,   735,
     736,   737,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     348,   349,   350,   351,   750,   751,    -1,   753,   754,    -1,
      -1,   292,   360,    -1,   295,   296,   297,    -1,    -1,   367,
      -1,   369,   571,    -1,    -1,    -1,    -1,   714,    -1,    -1,
      -1,    -1,    -1,   720,    -1,   316,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   738,    -1,    -1,    -1,   742,    -1,    -1,    -1,    -1,
     609,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   306,    -1,
     619,    -1,   621,    -1,    -1,    -1,    -1,   315,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   434,   435,   436,    -1,
     438,   372,   373,    -1,   442,    -1,   711,   378,    -1,    -1,
     381,   716,   651,   451,    -1,    -1,    -1,    -1,   657,   658,
     659,   459,    -1,    -1,   663,   664,   665,   666,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   674,   364,    -1,    -1,    -1,
     368,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   486,   377,
     488,   489,    -1,    -1,    -1,   493,   427,    -1,    -1,    -1,
      -1,    -1,   390,   391,   392,   393,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   714,   715,    -1,    -1,    -1,
      -1,   720,   721,    -1,   723,   724,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   422,    -1,    -1,    -1,    -1,   738,
      -1,   429,    -1,   742,    -1,    -1,    -1,    -1,   747,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   755,   756,   757,   758,
      -1,   760,   761,    -1,   362,    -1,   497,    -1,    -1,    -1,
      -1,    -1,   370,   504,    -1,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    -1,   581,    -1,    -1,    32,    -1,   586,    -1,
      -1,   589,   590,    -1,    -1,    41,    -1,   595,    -1,    45,
      -1,    47,    -1,    -1,   492,   603,   494,   495,   496,    55,
     498,    -1,    -1,    59,    -1,    -1,    -1,   505,   506,    65,
      -1,    -1,    68,    -1,    -1,    -1,   514,    -1,   426,    -1,
      -1,    -1,   430,    79,    80,   633,   634,    -1,    84,    -1,
      -1,    -1,    88,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    -1,    -1,    -1,    -1,   454,   455,   456,   457,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     126,    -1,    -1,    -1,   572,   573,   574,   485,    -1,   577,
      -1,   689,   490,    -1,    -1,    -1,    -1,   695,   696,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     651,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   659,    -1,
      -1,    -1,   663,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   752,    -1,   644,    -1,    -1,    -1,
     648,    -1,   650,    -1,   652,    -1,   764,   765,   656,   767,
     768,    -1,    -1,    -1,   662,    -1,    -1,    -1,   576,    -1,
      -1,    -1,    -1,    -1,   715,   673,    -1,   675,    -1,    -1,
      -1,    -1,   723,    -1,   592,    -1,   594,    -1,    -1,    -1,
      -1,    -1,   600,    -1,    -1,    19,    -1,    -1,    -1,    -1,
      -1,    -1,    26,    -1,    28,    -1,    30,    31,    -1,    33,
      34,    35,    -1,    -1,    -1,   713,    -1,    -1,    -1,    -1,
     718,   719,    46,    -1,    48,    -1,    50,    -1,   636,   637,
     638,    -1,   640,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    66,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      74,    -1,    76,    77,    78,    -1,    -1,    81,    82,    83,
      -1,   759,    -1,    -1,    88,    -1,    -1,    -1,    -1,    93,
      -1,    -1,    -1,    -1,   772,    -1,   684,   775,   686,    -1,
     688,    -1,    -1,    -1,     0,   693,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   704,    -1,   706,    -1,
      16,    17,    18,    -1,    -1,    -1,   130,    23,    -1,    -1,
      -1,    -1,   136,   137,    -1,    -1,    -1,    -1,    -1,    -1,
     728,    -1,    -1,    39,   732,   733,    42,    -1,    44,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    52,    53,    54,    -1,
      56,    57,    58,    -1,    60,    -1,    62,    -1,    64,    -1,
      -1,    67,    -1,    -1,    -1,    -1,    -1,    73,   766,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   776,   777,
      86,    -1,    -1,    -1,    -1,    91,    -1,    -1,    94,    -1,
      -1,    -1,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
       5,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    24,
      -1,    -1,    -1,    28,    29,    -1,    -1,    32,    33,    34,
      35,    -1,    37,    38,    -1,    -1,    41,    -1,    -1,    -1,
      45,    -1,    -1,    48,    -1,    -1,    51,    -1,    -1,    -1,
      55,    -1,    -1,    -1,    59,    -1,    -1,    -1,    63,    -1,
      -1,    66,    -1,    68,    -1,    -1,    16,    17,    18,    -1,
      -1,    76,    -1,    23,    -1,    80,    -1,    82,    -1,    84,
      85,    -1,    87,    88,    89,    90,    -1,    -1,    93,    39,
      -1,    -1,    42,    -1,    44,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    52,    53,    54,    -1,    56,    57,    58,    -1,
      60,    -1,    62,    -1,    64,    -1,    -1,    67,    -1,    -1,
      -1,   126,    -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    86,    -1,    -1,    -1,
      -1,    91,    -1,    -1,    94,    -1,    -1,    -1,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,    18,    -1,    20,    21,
      -1,    23,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    -1,
      42,    -1,    44,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      52,    53,    54,    -1,    56,    -1,    58,    -1,    60,    -1,
      62,    -1,    64,    -1,    -1,    67,    -1,    -1,    -1,    -1,
      -1,    73,    -1,    75,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    86,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,    18,    -1,    20,    21,    -1,    23,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    -1,    42,    -1,
      44,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    52,    53,
      54,    -1,    56,    -1,    58,    -1,    60,    -1,    62,    -1,
      64,    -1,    -1,    67,    -1,    -1,    -1,    -1,    -1,    73,
      -1,    75,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,    18,    -1,    20,    21,    -1,    23,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    -1,    42,    -1,    44,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    52,    53,    54,    -1,
      56,    -1,    58,    -1,    60,    -1,    62,    -1,    64,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    73,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
      18,    -1,    -1,    -1,    -1,    23,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    42,    -1,    44,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    52,    53,    54,    -1,    56,    -1,
      58,    -1,    60,    -1,    62,    -1,    64,    -1,    -1,    67,
      -1,    -1,    -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    86,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,    18,    -1,
      -1,    -1,    -1,    23,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    42,    -1,    44,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    52,    53,    54,    -1,    56,    -1,    58,    -1,
      60,    -1,    62,    -1,    64,    -1,    -1,    67,    -1,    -1,
      -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    86,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,    18,    -1,    20,    21,
      19,    -1,    -1,    -1,    -1,    -1,    -1,    26,    -1,    28,
      -1,    30,    31,    -1,    33,    34,    35,    -1,    40,    -1,
      42,    -1,    -1,    -1,    -1,    -1,    -1,    46,    -1,    48,
      -1,    50,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      62,    -1,    -1,    -1,    -1,    -1,    -1,    66,    -1,    -1,
      -1,    73,    -1,    -1,    -1,    74,    -1,    76,    77,    78,
      -1,    -1,    81,    82,    83,    -1,    -1,    -1,    -1,    88,
      -1,    -1,    -1,    -1,    93,    -1,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,    18,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    24,    -1,    -1,    -1,    28,    29,    -1,    -1,
      32,    33,    34,    35,    -1,    37,    38,    -1,    42,    41,
      -1,    -1,    -1,    45,    -1,    -1,    48,    -1,    -1,    51,
      -1,    -1,    -1,    55,    -1,    -1,    -1,    59,    62,    -1,
      -1,    63,    -1,    -1,    66,    -1,    68,    -1,    -1,    73,
      -1,    -1,    -1,    -1,    76,    -1,    -1,    -1,    80,    -1,
      82,    -1,    84,    85,    -1,    87,    88,    89,    90,    -1,
      -1,    93,    -1,    -1,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,    24,    -1,   126,    -1,    -1,    -1,    -1,    -1,
      32,    33,    34,    -1,    -1,    37,    38,    -1,    -1,    41,
      -1,    -1,    -1,    45,    -1,    -1,    -1,    -1,    -1,    51,
      -1,    -1,    -1,    55,    -1,    -1,    -1,    59,    -1,    -1,
      -1,    63,    -1,    -1,    66,    -1,    68,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    76,    -1,    -1,    -1,    80,    -1,
      82,    -1,    84,    85,    -1,    -1,    88,    89,    90,    -1,
      -1,    93,    -1,    -1,    -1,    -1,    98,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   126,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125
  };

  /* STOS_[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
  const unsigned char
  ds9parse::yystos_[] =
  {
         0,   141,   184,     0,    18,    23,    39,    42,    44,    52,
      53,    54,    56,    57,    58,    60,    62,    64,    67,    73,
      86,    91,    94,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   142,   143,   174,   175,   176,   195,    71,    72,   159,
      24,    32,    33,    34,    37,    38,    41,    45,    51,    55,
      59,    63,    66,    68,    76,    80,    82,    84,    85,    88,
      89,    90,    93,    98,   126,   178,   180,   181,   146,     3,
     143,   211,    16,    17,   157,   144,   145,    19,    26,    28,
      30,    31,    33,    34,    35,    46,    48,    50,    66,    74,
      76,    77,    78,    81,    82,    83,    88,    93,   130,   136,
     137,   197,   199,   135,   135,   135,   135,   135,   135,   135,
     135,   135,   135,   135,   135,   135,   135,   135,   130,   131,
     149,   161,   149,   157,   149,   149,   132,   162,   162,   162,
     162,   162,   162,   162,   162,   162,   162,   162,   162,   162,
     162,   200,   162,   162,   162,   201,   162,   162,    31,    33,
      34,    78,    82,    88,    91,    93,   147,   148,   197,   198,
     199,     5,    67,   174,   176,   183,     3,     3,     5,     3,
      22,    26,    27,    30,    36,    43,   127,   196,    20,    21,
      40,    67,    75,   174,   176,   177,   182,     5,     3,     4,
       7,     8,   158,   166,     3,     3,   175,     3,     3,    49,
      69,    70,    71,    72,    92,   128,   129,   160,   150,   181,
       7,    11,    12,    13,    14,    15,   158,   170,   171,   172,
     173,   173,   173,   173,   173,   173,   173,   173,   173,   173,
     133,   163,   173,   173,   173,   162,   173,   173,   173,   162,
     173,   173,   162,   162,   162,   162,   162,   162,     3,   162,
       5,   198,   176,     5,     3,     3,     3,   174,   177,   174,
     176,   177,   174,   177,     5,   161,   161,   161,   161,   161,
     161,   161,   161,   161,   161,   161,   161,   161,   161,   161,
     161,   161,   134,   164,   161,   161,   163,   173,   203,   204,
     161,   161,   161,   203,   161,   163,   161,   173,   173,   173,
     173,   173,   173,   173,     5,   174,     7,    11,    12,   158,
     170,   172,   172,     7,     9,    10,    11,    12,   158,   167,
       7,     9,    10,    11,    12,   158,   168,   166,   167,   167,
     167,   165,   166,   166,   168,   166,   134,   130,   151,   211,
     173,   166,   164,   161,   163,   173,   168,   173,   163,     5,
     164,   167,   161,   161,   161,   161,   161,   163,   161,     3,
     177,   161,   161,   161,   161,   161,   161,   161,   161,   161,
     163,   163,   163,   163,   161,   161,   161,    24,    28,    29,
      32,    33,    34,    35,    37,    38,    48,    55,    66,    76,
      82,    85,    87,    88,    89,    90,    93,   126,   152,   178,
     185,   186,   163,   161,   151,   204,   164,   161,   161,   163,
     164,   163,   151,   161,   167,   167,   165,   173,   173,   164,
     167,     3,   167,     7,     9,    10,    11,    12,   158,     7,
     158,   165,   168,   166,   164,   164,   164,   164,   166,   165,
     168,   166,   135,   135,   135,   135,   135,   135,   135,   135,
     135,   135,   135,   135,   135,   135,   135,   135,   135,   135,
       5,   135,   153,   161,   211,   164,   166,   151,   167,   165,
     164,   151,   202,   166,   163,   163,   163,   161,   163,   154,
     155,   185,   211,   161,   161,   163,   163,   161,   161,   151,
     151,   151,   151,   161,   163,   161,   161,    61,   193,   194,
      25,    32,    41,    45,    47,    55,    59,    65,    68,    79,
      80,    84,    88,    95,    96,    97,   126,   179,     5,    67,
     174,   176,   188,     3,    61,   189,   190,     3,    61,   191,
     192,     5,     3,   196,    67,    75,   174,   176,   177,   187,
       5,     5,   166,     3,     3,     3,   211,   160,     5,   186,
     151,   161,   163,   163,   163,   151,   164,   163,   164,   164,
     164,   167,   164,     5,   156,   211,   166,    69,   167,   169,
     205,   206,   164,   138,   164,   165,   169,     3,     3,   138,
     164,     7,   158,   165,   167,   169,   209,   210,     3,   132,
      45,    68,    80,    45,    68,    80,     5,   176,     5,   132,
       3,   132,     3,     3,   174,   177,   174,   176,   177,   174,
     177,   211,   166,   169,   207,   208,   164,   164,   164,   151,
     164,   154,   154,   154,   163,   154,   211,     5,   163,   135,
     163,   161,   163,   151,   139,   151,   163,   161,   161,   161,
     139,   151,   163,   161,   161,   161,   161,   207,     5,     5,
     207,   207,   174,   163,   161,   163,   151,   151,   151,   151,
     164,   211,   164,     3,   164,   206,   164,    26,   164,   165,
     168,   167,    46,   164,   167,   165,   165,   210,   168,   133,
       3,   133,   133,   177,   164,   208,   164,   154,   154,   151,
     151,   162,   151,   163,   161,   161,   162,   151,   163,   163,
     161,   132,     3,   132,   132,   151,   151,   173,   164,   168,
     167,   173,   164,   164,   168,   209,   205,   209,   161,   151,
     161,   161,   161,   151,   151,   161,   133,   161,   133,   133,
     168,     3,     3,   168,     3,   132,   132,   161,   161,   163,
     161,   161,   166,   166,   165,   165,   164,   165,   165,   133,
     133,   163,   163,   151,   163,   163,   164,   164,   151,   151
  };

#if YYDEBUG
  /* TOKEN_NUMBER_[YYLEX-NUM] -- Internal symbol number corresponding
     to YYLEX-NUM.  */
  const unsigned short int
  ds9parse::yytoken_number_[] =
  {
         0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
      35,    44,    40,    41,   124,    61,    43,    45,    38,    33
  };
#endif

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
  const unsigned char
  ds9parse::yyr1_[] =
  {
         0,   140,   141,   142,   142,   143,   143,   143,   143,   143,
     144,   143,   145,   143,   146,   143,   143,   143,   143,   147,
     147,   147,   148,   147,   149,   150,   149,   151,   152,   151,
     151,   153,   151,   154,   155,   154,   154,   156,   154,   157,
     157,   158,   158,   159,   159,   160,   160,   160,   160,   160,
     160,   160,   160,   160,   161,   161,   162,   162,   163,   163,
     164,   164,   164,   165,   165,   166,   166,   166,   167,   167,
     167,   167,   167,   167,   168,   168,   168,   168,   168,   168,
     169,   170,   171,   172,   173,   173,   173,   173,   173,   173,
     173,   174,   174,   174,   174,   174,   175,   175,   175,   175,
     175,   175,   175,   175,   175,   175,   175,   175,   175,   175,
     175,   175,   175,   175,   175,   175,   175,   175,   175,   175,
     175,   175,   175,   175,   176,   176,   176,   176,   176,   176,
     176,   176,   176,   176,   177,   177,   177,   178,   178,   178,
     178,   178,   178,   178,   178,   178,   178,   179,   179,   179,
     179,   179,   179,   179,   179,   179,   179,   179,   179,   179,
     179,   179,   179,   179,   179,   179,   179,   179,   180,   180,
     181,   181,   181,   181,   181,   181,   181,   181,   181,   181,
     181,   181,   181,   181,   181,   181,   181,   181,   181,   182,
     182,   182,   182,   182,   182,   182,   182,   182,   183,   183,
     183,   183,   184,   185,   185,   186,   186,   186,   186,   186,
     186,   186,   186,   186,   186,   186,   186,   186,   186,   186,
     186,   186,   186,   186,   186,   186,   186,   186,   187,   187,
     187,   187,   187,   187,   187,   187,   187,   188,   188,   188,
     188,   190,   189,   189,   192,   191,   191,   194,   193,   193,
     195,   196,   196,   196,   196,   196,   196,   196,   197,   197,
     198,   198,   198,   198,   198,   198,   198,   199,   199,   199,
     199,   199,   200,   199,   201,   199,   199,   199,   199,   202,
     199,   199,   199,   199,   199,   199,   199,   199,   199,   199,
     199,   199,   199,   199,   199,   199,   199,   199,   199,   199,
     199,   199,   199,   203,   203,   204,   205,   205,   206,   207,
     207,   208,   209,   209,   210,   211
  };

  /* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
  const unsigned char
  ds9parse::yyr2_[] =
  {
         0,     2,     3,     3,     2,     0,     2,     1,     3,     2,
       0,     3,     0,     3,     0,     3,     2,     3,     3,     1,
       2,     2,     0,     2,     0,     0,     3,     1,     0,     4,
       3,     0,     5,     1,     0,     3,     2,     0,     4,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     1,     0,     1,     0,     1,
       0,     1,     2,     0,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     3,     3,     3,     3,     3,
       3,     1,     1,     1,     3,     3,     3,     3,     3,     3,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     1,     2,     2,     1,     2,     2,     1,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     1,
       3,     3,     4,     3,     3,     3,     1,     1,     1,     3,
       4,     4,     3,     3,     3,     7,     3,     3,     3,     4,
       2,     2,     2,     2,     2,     2,     1,     1,     2,     1,
       1,     1,     0,     3,     1,     3,     3,     4,     3,     3,
       3,     3,     5,     1,     1,     1,     3,     4,     4,     3,
       3,     3,     7,     3,     3,     3,     3,     3,     4,     2,
       2,     2,     2,     2,     2,     1,     1,     2,     1,     1,
       1,     0,     7,     1,     0,    10,     1,     0,    10,     1,
       0,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       6,     8,    10,    10,     8,     8,     8,     8,     8,    10,
      10,    10,     0,     7,     0,     7,     8,    10,     6,     0,
       9,     6,     8,     8,    10,    10,    12,    12,    12,    14,
      14,    18,    12,    14,    18,    18,    20,    20,    10,    12,
      12,     5,     8,     3,     1,     1,     3,     1,     1,     3,
       1,     1,     3,     1,     3,     0
  };


  /* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
     First, the terminals, then, starting at \a yyntokens_, nonterminals.  */
  const char*
  const ds9parse::yytname_[] =
  {
    "$end", "error", "$undefined", "INT", "REAL", "STRING", "COLOR",
  "ANGDEGREE", "ANGRADIAN", "ARCMINUTE", "ARCSECOND", "PHYCOORD",
  "IMGCOORD", "SEXSTR", "HMSSTR", "DMSSTR", "EOF_", "EOL_", "AMPLIFIER_",
  "ANNULUS_", "ARCMIN_", "ARCSEC_", "ARROW_", "B1950_", "BACKGROUND_",
  "BEGIN_", "BOX_", "BOXCIRCLE_", "BPANDA_", "CALLBACK_", "CIRCLE_",
  "CIRCLE3D_", "COLOR_", "COMPASS_", "COMPOSITE_", "CPANDA_", "CROSS_",
  "DASH_", "DASHLIST_", "DEBUG_", "DEGREES_", "DELETE_", "DETECTOR_",
  "DIAMOND_", "ECLIPTIC_", "EDIT_", "ELLIPSE_", "END_", "EPANDA_",
  "FALSE_", "FIELD_", "FIXED_", "FK4_", "FK4_NO_E_", "FK5_", "FONT_",
  "GALACTIC_", "GLOBAL_", "HELIOECLIPTIC_", "HIGHLITE_", "ICRS_",
  "IGNORE_", "IMAGE_", "INCLUDE_", "J2000_", "KEY_", "LINE_", "LINEAR_",
  "MOVE_", "N_", "NO_", "OFF_", "ON_", "PHYSICAL_", "PIE_", "PIXELS_",
  "POINT_", "POLYGON_", "PROJECTION_", "PROPERTY_", "ROTATE_", "ROTBOX_",
  "RULER_", "SEGMENT_", "SELECT_", "SOURCE_", "SUPERGALACTIC_", "TAG_",
  "TEXT_", "TEXTANGLE_", "TEXTROTATE_", "TILE_", "TRUE_", "VECTOR_",
  "VERSION_", "UNHIGHLITE_", "UNSELECT_", "UPDATE_", "WCS_", "WCSA_",
  "WCSB_", "WCSC_", "WCSD_", "WCSE_", "WCSF_", "WCSG_", "WCSH_", "WCSI_",
  "WCSJ_", "WCSK_", "WCSL_", "WCSM_", "WCSN_", "WCSO_", "WCSP_", "WCSQ_",
  "WCSR_", "WCSS_", "WCST_", "WCSU_", "WCSV_", "WCSW_", "WCSX_", "WCSY_",
  "WCSZ_", "WCS0_", "WIDTH_", "X_", "Y_", "YES_", "'#'", "','", "'('",
  "')'", "'|'", "'='", "'+'", "'-'", "'&'", "'!'", "$accept", "start",
  "commands", "command", "$@1", "$@2", "$@3", "hash", "$@4", "comment",
  "$@5", "shapeComment", "$@6", "$@7", "nonshapeComment", "$@8", "$@9",
  "terminator", "numeric", "debug", "yesno", "sp", "bp", "ep",
  "conjuction", "optangle", "angle", "value", "vvalue", "numberof",
  "sexagesimal", "hms", "dms", "coord", "coordSystem", "wcsSystem",
  "skyFrame", "skyDist", "property", "callBack", "global",
  "globalProperty", "globalRuler", "globalCompass", "initGlobal", "local",
  "localProperty", "localRuler", "localCompass", "localCpanda", "$@10",
  "localEpanda", "$@11", "localBpanda", "$@12", "initLocal", "pointShape",
  "include", "nonshape", "shape", "$@13", "$@14", "$@15", "polyNodes",
  "polyNode", "aRads", "aRad", "aAngs", "aAng", "vRads", "vRad",
  "postLocal", YY_NULL
  };

#if YYDEBUG
  /* YYRHS -- A `-1'-separated list of the rules' RHS.  */
  const ds9parse::rhs_number_type
  ds9parse::yyrhs_[] =
  {
       141,     0,    -1,   184,   142,   211,    -1,   142,   143,   157,
      -1,   143,   157,    -1,    -1,    39,   159,    -1,    94,    -1,
      57,   180,   149,    -1,    91,     3,    -1,    -1,   174,   144,
     149,    -1,    -1,   176,   145,   149,    -1,    -1,    67,   146,
     149,    -1,   195,   199,    -1,   195,   197,   199,    -1,   195,
     130,   147,    -1,   198,    -1,   197,   198,    -1,    91,     3,
      -1,    -1,   148,     5,    -1,    -1,    -1,   130,   150,     5,
      -1,   211,    -1,    -1,   130,   152,     5,   211,    -1,   130,
     185,   211,    -1,    -1,   130,   185,   153,     5,   211,    -1,
     211,    -1,    -1,   155,     5,   211,    -1,   185,   211,    -1,
      -1,   185,   156,     5,   211,    -1,    17,    -1,    16,    -1,
       4,    -1,     3,    -1,    72,    -1,    71,    -1,     3,    -1,
     129,    -1,   128,    -1,    72,    -1,    92,    -1,    70,    -1,
      69,    -1,    71,    -1,    49,    -1,    -1,   131,    -1,    -1,
     132,    -1,    -1,   133,    -1,    -1,   134,    -1,   134,   134,
      -1,    -1,   166,    -1,   158,    -1,     7,    -1,     8,    -1,
     158,    -1,    11,    -1,    12,    -1,     7,    -1,     9,    -1,
      10,    -1,   158,   161,   158,    -1,    11,   161,    11,    -1,
      12,   161,    12,    -1,     7,   161,     7,    -1,     9,   161,
       9,    -1,    10,   161,    10,    -1,    69,   135,     3,    -1,
      13,    -1,    14,    -1,    15,    -1,   170,   161,   170,    -1,
     171,   161,   172,    -1,   172,   161,   172,    -1,   158,   161,
     158,    -1,     7,   161,     7,    -1,    12,   161,    12,    -1,
      11,   161,    11,    -1,    62,    -1,    73,    -1,    42,    -1,
      18,    -1,   175,    -1,    98,    -1,    99,    -1,   100,    -1,
     101,    -1,   102,    -1,   103,    -1,   104,    -1,   105,    -1,
     106,    -1,   107,    -1,   108,    -1,   109,    -1,   110,    -1,
     111,    -1,   112,    -1,   113,    -1,   114,    -1,   115,    -1,
     116,    -1,   117,    -1,   118,    -1,   119,    -1,   120,    -1,
     121,    -1,   122,    -1,   123,    -1,   124,    -1,   125,    -1,
      52,    -1,    23,    -1,    53,    -1,    54,    -1,    64,    -1,
      60,    -1,    56,    -1,    86,    -1,    44,    -1,    58,    -1,
      40,    -1,    20,    -1,    21,    -1,    84,    -1,    59,    -1,
      37,    -1,    51,    -1,    45,    -1,    68,    -1,    80,    -1,
      41,    -1,    63,    -1,    85,    -1,    84,    -1,    96,    -1,
      59,    -1,    95,    -1,    25,    68,    -1,    68,    -1,    47,
      68,    -1,    25,    45,    -1,    45,    -1,    47,    45,    -1,
      25,    80,    -1,    80,    -1,    47,    80,    -1,    41,    -1,
      88,    -1,    32,    -1,   126,    -1,    79,    -1,    55,    -1,
      65,    -1,    97,    -1,   180,   161,   181,    -1,   181,    -1,
     178,   135,   160,    -1,    32,   135,     5,    -1,    38,   135,
       3,     3,    -1,   126,   135,     3,    -1,    55,   135,     5,
      -1,    88,   135,     5,    -1,    37,    -1,    85,    -1,    24,
      -1,    76,   135,   196,    -1,    76,   135,   196,     3,    -1,
      66,   135,     3,     3,    -1,    93,   135,     3,    -1,    34,
     135,     3,    -1,    82,   135,   182,    -1,    33,   135,   183,
       5,     5,     3,     3,    -1,    89,   135,   166,    -1,    90,
     135,     3,    -1,    98,   135,   175,    -1,   174,   176,   174,
     177,    -1,   174,   174,    -1,   174,   177,    -1,   176,   174,
      -1,   176,   177,    -1,    67,   174,    -1,    67,   177,    -1,
     177,    -1,    75,    -1,   174,   176,    -1,   174,    -1,   176,
      -1,    67,    -1,    -1,   185,   161,   186,    -1,   186,    -1,
     178,   135,   160,    -1,    32,   135,     5,    -1,    38,   135,
       3,     3,    -1,   126,   135,     3,    -1,    55,   135,     5,
      -1,    88,   135,     5,    -1,    87,   135,     5,    -1,    29,
     135,   179,     5,     5,    -1,    37,    -1,    85,    -1,    24,
      -1,    76,   135,   196,    -1,    76,   135,   196,     3,    -1,
      66,   135,     3,     3,    -1,    93,   135,     3,    -1,    34,
     135,     3,    -1,    82,   135,   187,    -1,    33,   135,   188,
       5,     5,     3,     3,    -1,    89,   135,   166,    -1,    90,
     135,     3,    -1,    35,   135,   189,    -1,    48,   135,   191,
      -1,    28,   135,   193,    -1,   174,   176,   174,   177,    -1,
     174,   174,    -1,   174,   177,    -1,   176,   174,    -1,   176,
     177,    -1,    67,   174,    -1,    67,   177,    -1,   177,    -1,
      75,    -1,   174,   176,    -1,   174,    -1,   176,    -1,    67,
      -1,    -1,   190,   132,   207,   133,   132,   205,   133,    -1,
      61,    -1,    -1,   192,   132,   207,   133,   132,   209,   133,
     132,   166,   133,    -1,    61,    -1,    -1,   194,   132,   207,
     133,   132,   209,   133,   132,   166,   133,    -1,    61,    -1,
      -1,    30,    -1,    26,    -1,    43,    -1,    36,    -1,   127,
      -1,    22,    -1,    27,    -1,   136,    -1,   137,    -1,    88,
     162,   173,   163,   164,   154,    -1,    34,   162,   173,   161,
     165,   163,   164,   154,    -1,    93,   162,   173,   161,   167,
     161,   166,   163,   164,   154,    -1,    78,   162,   173,   161,
     173,   161,   167,   163,   164,   154,    -1,    82,   162,   173,
     161,   173,   163,   164,   154,    -1,    33,   162,   173,   161,
     167,   163,   164,   154,    -1,    31,   162,   173,   161,   167,
     163,   164,   154,    -1,    30,   162,   173,   161,   167,   163,
     164,   151,    -1,    31,   162,   173,   161,   167,   163,   164,
     151,    -1,    46,   162,   173,   161,   168,   161,   165,   163,
     164,   151,    -1,    26,   162,   173,   161,   168,   161,   165,
     163,   164,   151,    -1,    81,   162,   173,   161,   168,   161,
     165,   163,   164,   151,    -1,    -1,    77,   200,   162,   203,
     163,   164,   151,    -1,    -1,    83,   201,   162,   203,   163,
     164,   151,    -1,    66,   162,   173,   161,   173,   163,   164,
     151,    -1,    93,   162,   173,   161,   167,   161,   166,   163,
     164,   151,    -1,    88,   162,   173,   163,   164,   151,    -1,
      -1,    88,   162,   173,   161,     5,   163,   202,   164,   151,
      -1,    76,   162,   173,   163,   164,   151,    -1,    82,   162,
     173,   161,   173,   163,   164,   151,    -1,    33,   162,   173,
     161,   167,   163,   164,   151,    -1,    78,   162,   173,   161,
     173,   161,   167,   163,   164,   151,    -1,    19,   162,   173,
     161,   167,   161,   167,   163,   164,   151,    -1,    19,   162,
     173,   161,   167,   161,   167,   161,   205,   163,   164,   151,
      -1,    19,   162,   173,   161,   167,   161,   167,   161,   169,
     163,   164,   151,    -1,    46,   162,   173,   161,   168,   161,
     168,   161,   165,   163,   164,   151,    -1,    46,   162,   173,
     161,   168,   161,   168,   161,   169,   161,   165,   163,   164,
     151,    -1,    46,   162,   173,   161,   168,   161,   168,   161,
     209,   161,   165,   163,   164,   151,    -1,    46,   162,   173,
     161,   168,   161,   165,   163,   138,   139,    46,   162,   173,
     161,   168,   161,   165,   163,    -1,    26,   162,   173,   161,
     168,   161,   168,   161,   165,   163,   164,   151,    -1,    26,
     162,   173,   161,   168,   161,   168,   161,   169,   161,   165,
     163,   164,   151,    -1,    26,   162,   173,   161,   168,   161,
     165,   163,   138,   139,    26,   162,   173,   161,   168,   161,
     165,   163,    -1,    35,   162,   173,   161,   166,   161,   166,
     161,     3,   161,   167,   161,   167,   161,     3,   163,   164,
     151,    -1,    48,   162,   173,   161,   166,   161,   166,   161,
       3,   161,   168,   161,   168,   161,     3,   161,   165,   163,
     164,   151,    -1,    28,   162,   173,   161,   166,   161,   166,
     161,     3,   161,   168,   161,   168,   161,     3,   161,   165,
     163,   164,   151,    -1,    74,   162,   173,   161,   166,   161,
     166,   163,   164,   151,    -1,    74,   162,   173,   161,   166,
     161,   166,   161,   207,   163,   164,   151,    -1,    74,   162,
     173,   161,   166,   161,   166,   161,   169,   163,   164,   151,
      -1,    50,   162,   163,   164,   151,    -1,    34,   162,   173,
     161,   165,   163,   164,   151,    -1,   203,   161,   204,    -1,
     204,    -1,   173,    -1,   205,   161,   206,    -1,   206,    -1,
     167,    -1,   207,   161,   208,    -1,   208,    -1,   166,    -1,
     209,   161,   210,    -1,   210,    -1,   167,   161,   167,    -1,
      -1
  };

  /* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
     YYRHS.  */
  const unsigned short int
  ds9parse::yyprhs_[] =
  {
         0,     0,     3,     7,    11,    14,    15,    18,    20,    24,
      27,    28,    32,    33,    37,    38,    42,    45,    49,    53,
      55,    58,    61,    62,    65,    66,    67,    71,    73,    74,
      79,    83,    84,    90,    92,    93,    97,   100,   101,   106,
     108,   110,   112,   114,   116,   118,   120,   122,   124,   126,
     128,   130,   132,   134,   136,   137,   139,   140,   142,   143,
     145,   146,   148,   151,   152,   154,   156,   158,   160,   162,
     164,   166,   168,   170,   172,   176,   180,   184,   188,   192,
     196,   200,   202,   204,   206,   210,   214,   218,   222,   226,
     230,   234,   236,   238,   240,   242,   244,   246,   248,   250,
     252,   254,   256,   258,   260,   262,   264,   266,   268,   270,
     272,   274,   276,   278,   280,   282,   284,   286,   288,   290,
     292,   294,   296,   298,   300,   302,   304,   306,   308,   310,
     312,   314,   316,   318,   320,   322,   324,   326,   328,   330,
     332,   334,   336,   338,   340,   342,   344,   346,   348,   350,
     352,   354,   357,   359,   362,   365,   367,   370,   373,   375,
     378,   380,   382,   384,   386,   388,   390,   392,   394,   398,
     400,   404,   408,   413,   417,   421,   425,   427,   429,   431,
     435,   440,   445,   449,   453,   457,   465,   469,   473,   477,
     482,   485,   488,   491,   494,   497,   500,   502,   504,   507,
     509,   511,   513,   514,   518,   520,   524,   528,   533,   537,
     541,   545,   549,   555,   557,   559,   561,   565,   570,   575,
     579,   583,   587,   595,   599,   603,   607,   611,   615,   620,
     623,   626,   629,   632,   635,   638,   640,   642,   645,   647,
     649,   651,   652,   660,   662,   663,   674,   676,   677,   688,
     690,   691,   693,   695,   697,   699,   701,   703,   705,   707,
     709,   716,   725,   736,   747,   756,   765,   774,   783,   792,
     803,   814,   825,   826,   834,   835,   843,   852,   863,   870,
     871,   881,   888,   897,   906,   917,   928,   941,   954,   967,
     982,   997,  1016,  1029,  1044,  1063,  1082,  1103,  1124,  1135,
    1148,  1161,  1167,  1176,  1180,  1182,  1184,  1188,  1190,  1192,
    1196,  1198,  1200,  1204,  1206,  1210
  };

  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
  const unsigned short int
  ds9parse::yyrline_[] =
  {
         0,   333,   333,   336,   337,   340,   341,   342,   344,   345,
     347,   347,   348,   348,   349,   349,   351,   352,   353,   356,
     357,   358,   359,   359,   362,   363,   363,   366,   367,   367,
     368,   369,   369,   372,   373,   373,   374,   375,   375,   378,
     379,   382,   383,   386,   387,   390,   392,   393,   394,   395,
     397,   398,   399,   400,   403,   404,   407,   408,   411,   412,
     415,   416,   417,   420,   421,   424,   425,   426,   429,   430,
     431,   432,   433,   434,   437,   444,   451,   458,   465,   472,
     481,   484,   487,   490,   493,   506,   514,   522,   529,   537,
     544,   552,   553,   554,   555,   556,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   601,   602,   603,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   641,   642,
     645,   650,   655,   660,   661,   666,   671,   676,   681,   686,
     687,   692,   697,   698,   702,   703,   712,   713,   714,   717,
     724,   731,   738,   745,   752,   759,   766,   773,   782,   787,
     792,   797,   804,   846,   847,   850,   851,   852,   857,   858,
     859,   860,   861,   863,   864,   865,   867,   868,   869,   870,
     871,   872,   873,   880,   881,   882,   883,   884,   887,   894,
     901,   908,   915,   922,   929,   936,   943,   952,   957,   962,
     967,   974,   974,   975,   978,   978,   980,   983,   983,   985,
     988,  1037,  1038,  1039,  1040,  1041,  1042,  1043,  1046,  1047,
    1050,  1055,  1060,  1066,  1076,  1085,  1096,  1106,  1113,  1121,
    1144,  1167,  1176,  1176,  1183,  1183,  1191,  1199,  1207,  1214,
    1214,  1222,  1230,  1239,  1249,  1258,  1265,  1275,  1283,  1293,
    1303,  1315,  1323,  1337,  1347,  1356,  1378,  1402,  1427,  1428,
    1429,  1431,  1433,  1442,  1443,  1446,  1449,  1450,  1453,  1460,
    1461,  1464,  1471,  1472,  1475,  1479
  };

  // Print the state stack on the debug stream.
  void
  ds9parse::yystack_print_ ()
  {
    *yycdebug_ << "Stack now";
    for (state_stack_type::const_iterator i = yystate_stack_.begin ();
	 i != yystate_stack_.end (); ++i)
      *yycdebug_ << ' ' << *i;
    *yycdebug_ << std::endl;
  }

  // Report on the debug stream that the rule \a yyrule is going to be reduced.
  void
  ds9parse::yy_reduce_print_ (int yyrule)
  {
    unsigned int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    /* Print the symbols being reduced, and their result.  */
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
	       << " (line " << yylno << "):" << std::endl;
    /* The symbols being reduced.  */
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
		       yyrhs_[yyprhs_[yyrule] + yyi],
		       &(yysemantic_stack_[(yynrhs) - (yyi + 1)]),
		       &(yylocation_stack_[(yynrhs) - (yyi + 1)]));
  }
#endif // YYDEBUG

  /* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
  ds9parse::token_number_type
  ds9parse::yytranslate_ (int t)
  {
    static
    const token_number_type
    translate_table[] =
    {
           0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   139,     2,   130,     2,     2,   138,     2,
     132,   133,     2,   136,   131,   137,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   135,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,   134,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129
    };
    if ((unsigned int) t <= yyuser_token_number_max_)
      return translate_table[t];
    else
      return yyundef_token_;
  }

  const int ds9parse::yyeof_ = 0;
  const int ds9parse::yylast_ = 2392;
  const int ds9parse::yynnts_ = 72;
  const int ds9parse::yyempty_ = -2;
  const int ds9parse::yyfinal_ = 3;
  const int ds9parse::yyterror_ = 1;
  const int ds9parse::yyerrcode_ = 256;
  const int ds9parse::yyntokens_ = 140;

  const unsigned int ds9parse::yyuser_token_number_max_ = 384;
  const ds9parse::token_number_type ds9parse::yyundef_token_ = 2;


} // yy
/* Line 1141 of lalr1.cc  */
#line 4355 "ds9parse.cpp"
/* Line 1142 of lalr1.cc  */
#line 1506 "/home/acdc/cartawork/CARTAvis/carta/cpp/plugins/RegionDs9/ds9parse.y"


static void setProps(unsigned short* props, unsigned short prop, int value)
{
  if (value)
    *props |= prop;
  else
    *props &= ~prop;
}

static  CoordSystem checkWCSSystem()
{
  switch (localSystem) {
  case  IMAGE:
  case  PHYSICAL:
    return  WCS;
  default:
   return localSystem;
  }
}

static  SkyFrame checkWCSSky()
{
  switch (localSystem) {
  case  IMAGE:
  case  PHYSICAL:
    return  FK5;
  default:
   return localSky;
  }
}

//pass error along to the driver (ParserDs9)
void yy::ds9parse::error( const yy::ds9parse::location_type &l, const std::string& m ){
    driver.error(l,m);
}


